#!/bin/sh
# Version:	1.0
# Author:	Remo Rickli
# Description:	Builds a NeDi archive and uploads it.

if [ "$1" = "ieee" ]
then 
	wget -O /var/nedi/inc/oui.txt  http://standards.ieee.org/regauth/oui/oui.txt
	wget -O /var/nedi/inc/iab.txt  http://standards.ieee.org/regauth/oui/iab.txt
else
	rm -f nedi-$1.tgz
	rm -rf nedi

	echo Creating Structure
	mkdir -p nedi/config
	mkdir -p nedi/contrib
	mkdir -p nedi/inc
	mkdir -p nedi/rrd
	mkdir -p nedi/sysobj

	mkdir -p nedi/html/img
	mkdir -p nedi/html/inc
	mkdir -p nedi/html/log

	echo Copying Files
	cp /var/nedi/*.pl nedi
	cp /var/nedi/nedi.conf nedi
	sed -i -e '/^usr/d' nedi/nedi.conf
	sed -i -e '/^mapip/d' nedi/nedi.conf
	sed -i -e 's/^rrdstep.*$/rrdstep\t\t3600/' nedi/nedi.conf

	cp /var/nedi/seedlist nedi
	sed -i -e '/^[^#;]*$/d' nedi/seedlist

	cp /var/nedi/inc/* nedi/inc
	cp /var/nedi/sysobj/*.def nedi/sysobj
	cp /var/nedi/contrib/* nedi/contrib

	cp /var/nedi/html/*.php nedi/html
	cp -R /var/nedi/html/inc nedi/html
	cp -R /var/nedi/html/languages nedi/html
	cp -R /var/nedi/html/themes nedi/html
	cp -R /var/nedi/html/img nedi/html
	cp -R /var/nedi/html/test nedi/html

	cp /var/nedi/html/log/msg.txt nedi/html/log
	cp /var/nedi/html/log/map-top.png nedi/html/log
	chmod -R 777 nedi/html/log

	echo Removing Unwanted Files
	find nedi -name ".*" -exec rm {} \;
	find nedi -name "*~" -exec rm {} \;

	echo Creating Archive
	tar  zcf nedi-$1.tgz nedi

	echo Uploading
	scp nedi-$1.tgz rickli@golem:Documents
	mv nedi-$1.tgz /var/tmp
fi
