-- MySQL dump 10.11
--
-- Host: localhost    Database: nedi
-- ------------------------------------------------------
-- Server version	5.0.84

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `chat`
--

CREATE DATABASE nedi;
USE nedi;


/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `chat` (
  `time` int(10) unsigned default NULL,
  `user` varchar(32) collate utf8_unicode_ci default NULL,
  `message` varchar(255) collate utf8_unicode_ci default NULL,
  KEY `time` (`time`),
  KEY `user` (`user`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `chat`
--

LOCK TABLES `chat` WRITE;
/*!40000 ALTER TABLE `chat` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `configs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `configs` (
  `device` varchar(64) character set utf8 collate utf8_bin NOT NULL,
  `config` mediumtext collate utf8_unicode_ci,
  `changes` mediumtext collate utf8_unicode_ci,
  `time` int(10) unsigned default NULL,
  PRIMARY KEY  (`device`),
  UNIQUE KEY `device` (`device`),
  KEY `device_2` (`device`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `configs`
--

LOCK TABLES `configs` WRITE;
/*!40000 ALTER TABLE `configs` DISABLE KEYS */;
/*!40000 ALTER TABLE `configs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devdel`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devdel` (
  `device` varchar(64) character set utf8 collate utf8_bin NOT NULL,
  `user` varchar(32) collate utf8_unicode_ci default NULL,
  `time` int(10) unsigned default NULL,
  PRIMARY KEY  (`device`),
  UNIQUE KEY `device` (`device`),
  KEY `device_2` (`device`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devdel`
--

LOCK TABLES `devdel` WRITE;
/*!40000 ALTER TABLE `devdel` DISABLE KEYS */;
/*!40000 ALTER TABLE `devdel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devices`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devices` (
  `name` varchar(64) character set utf8 collate utf8_bin NOT NULL,
  `ip` int(10) unsigned default NULL,
  `serial` varchar(32) collate utf8_unicode_ci default NULL,
  `type` varchar(32) collate utf8_unicode_ci default NULL,
  `firstseen` int(10) unsigned default NULL,
  `lastseen` int(10) unsigned default NULL,
  `services` tinyint(3) unsigned default NULL,
  `description` varchar(255) collate utf8_unicode_ci default NULL,
  `os` varchar(16) collate utf8_unicode_ci default NULL,
  `bootimage` varchar(64) collate utf8_unicode_ci default NULL,
  `location` varchar(255) collate utf8_unicode_ci default NULL,
  `contact` varchar(255) collate utf8_unicode_ci default NULL,
  `vtpdomain` varchar(32) collate utf8_unicode_ci default NULL,
  `vtpmode` tinyint(3) unsigned default NULL,
  `snmpversion` tinyint(3) unsigned default NULL,
  `community` varchar(32) collate utf8_unicode_ci default NULL,
  `cliport` smallint(5) unsigned default NULL,
  `login` varchar(32) collate utf8_unicode_ci default NULL,
  `icon` varchar(16) collate utf8_unicode_ci default NULL,
  `origip` int(10) unsigned default NULL,
  `cpu` tinyint(3) unsigned default NULL,
  `memcpu` int(10) unsigned default NULL,
  `temp` tinyint(3) unsigned default NULL,
  `cusvalue` int(10) unsigned default NULL,
  `cuslabel` varchar(32) collate utf8_unicode_ci default NULL,
  `sysobjid` varchar(255) collate utf8_unicode_ci default NULL,
  `logalarm` varchar(255) collate utf8_unicode_ci default NULL,
  `flags` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`name`),
  UNIQUE KEY `name` (`name`),
  KEY `name_2` (`name`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devices`
--

LOCK TABLES `devices` WRITE;
/*!40000 ALTER TABLE `devices` DISABLE KEYS */;
/*!40000 ALTER TABLE `devices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iftrack`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iftrack` (
  `mac` char(12) collate utf8_unicode_ci default NULL,
  `ifupdate` int(10) unsigned default NULL,
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `ifname` varchar(32) collate utf8_unicode_ci default NULL,
  `vlanid` smallint(5) unsigned default NULL,
  `ifmetric` tinyint(3) unsigned default NULL,
  KEY `mac` (`mac`),
  KEY `ifupdate` (`ifupdate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iftrack`
--

LOCK TABLES `iftrack` WRITE;
/*!40000 ALTER TABLE `iftrack` DISABLE KEYS */;
/*!40000 ALTER TABLE `iftrack` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `incidents`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `incidents` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `level` tinyint(3) unsigned default NULL,
  `device` varchar(64) collate utf8_unicode_ci default NULL,
  `deps` int(10) unsigned default NULL,
  `firstseen` int(10) unsigned default NULL,
  `lastseen` int(10) unsigned default NULL,
  `who` varchar(32) collate utf8_unicode_ci default NULL,
  `time` int(10) unsigned default NULL,
  `category` tinyint(3) unsigned default NULL,
  `comment` varchar(255) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `incidents`
--

LOCK TABLES `incidents` WRITE;
/*!40000 ALTER TABLE `incidents` DISABLE KEYS */;
/*!40000 ALTER TABLE `incidents` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `interfaces`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `interfaces` (
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `ifname` varchar(32) collate utf8_unicode_ci default NULL,
  `ifidx` bigint(20) unsigned default NULL,
  `linktype` char(4) collate utf8_unicode_ci default NULL,
  `type` int(10) unsigned default NULL,
  `mac` char(12) collate utf8_unicode_ci default NULL,
  `description` varchar(255) collate utf8_unicode_ci default NULL,
  `alias` varchar(64) collate utf8_unicode_ci default NULL,
  `status` tinyint(3) unsigned default NULL,
  `speed` bigint(20) unsigned default NULL,
  `duplex` char(2) collate utf8_unicode_ci default NULL,
  `vlid` smallint(5) unsigned default NULL,
  `inoct` bigint(20) unsigned default NULL,
  `inerr` int(10) unsigned default NULL,
  `outoct` bigint(20) unsigned default NULL,
  `outerr` int(10) unsigned default NULL,
  `dinoct` bigint(20) default NULL,
  `dinerr` int(11) default NULL,
  `doutoct` bigint(20) default NULL,
  `douterr` int(11) default NULL,
  `comment` varchar(255) collate utf8_unicode_ci default NULL,
  KEY `device` (`device`(8)),
  KEY `ifname` (`ifname`(8)),
  KEY `ifidx` (`ifidx`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `interfaces`
--

LOCK TABLES `interfaces` WRITE;
/*!40000 ALTER TABLE `interfaces` DISABLE KEYS */;
/*!40000 ALTER TABLE `interfaces` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iptrack`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iptrack` (
  `mac` char(12) collate utf8_unicode_ci default NULL,
  `ipupdate` int(10) unsigned default NULL,
  `name` varchar(64) collate utf8_unicode_ci default NULL,
  `ip` int(10) unsigned default NULL,
  KEY `mac` (`mac`),
  KEY `ipupdate` (`ipupdate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iptrack`
--

LOCK TABLES `iptrack` WRITE;
/*!40000 ALTER TABLE `iptrack` DISABLE KEYS */;
/*!40000 ALTER TABLE `iptrack` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `links`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `links` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `ifname` varchar(32) collate utf8_unicode_ci default NULL,
  `neighbour` varchar(64) character set utf8 collate utf8_bin default NULL,
  `nbrifname` varchar(32) collate utf8_unicode_ci default NULL,
  `bandwidth` bigint(20) unsigned default NULL,
  `type` char(4) collate utf8_unicode_ci default NULL,
  `power` int(10) unsigned default NULL,
  `nbrduplex` char(2) collate utf8_unicode_ci default NULL,
  `nbrvlanid` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `device` (`device`(8)),
  KEY `ifname` (`ifname`(8)),
  KEY `neighbour` (`neighbour`(8)),
  KEY `nbrifname` (`nbrifname`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `links`
--

LOCK TABLES `links` WRITE;
/*!40000 ALTER TABLE `links` DISABLE KEYS */;
/*!40000 ALTER TABLE `links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `locations`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locations` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `region` varchar(32) character set utf8 collate utf8_bin NOT NULL,
  `city` varchar(32) collate utf8_unicode_ci default NULL,
  `building` varchar(32) collate utf8_unicode_ci default NULL,
  `x` smallint(5) unsigned default NULL,
  `y` smallint(5) unsigned default NULL,
  `comment` varchar(64) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`id`),
  KEY `region` (`region`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locations`
--

LOCK TABLES `locations` WRITE;
/*!40000 ALTER TABLE `locations` DISABLE KEYS */;
/*!40000 ALTER TABLE `locations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `messages`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `messages` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `level` tinyint(3) unsigned default NULL,
  `time` int(10) unsigned default NULL,
  `source` varchar(64) collate utf8_unicode_ci default NULL,
  `info` varchar(255) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `source` (`source`(8)),
  KEY `level` (`level`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `messages`
--

LOCK TABLES `messages` WRITE;
/*!40000 ALTER TABLE `messages` DISABLE KEYS */;
/*!40000 ALTER TABLE `messages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `modules`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `modules` (
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `slot` varchar(64) collate utf8_unicode_ci default NULL,
  `model` varchar(32) collate utf8_unicode_ci default NULL,
  `description` varchar(255) collate utf8_unicode_ci default NULL,
  `serial` varchar(32) collate utf8_unicode_ci default NULL,
  `hw` varchar(128) collate utf8_unicode_ci default NULL,
  `fw` varchar(128) collate utf8_unicode_ci default NULL,
  `sw` varchar(128) collate utf8_unicode_ci default NULL,
  `modidx` smallint(5) unsigned default NULL,
  KEY `device` (`device`(8)),
  KEY `slot` (`slot`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `modules`
--

LOCK TABLES `modules` WRITE;
/*!40000 ALTER TABLE `modules` DISABLE KEYS */;
/*!40000 ALTER TABLE `modules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `monitoring`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `monitoring` (
  `device` varchar(64) character set utf8 collate utf8_bin NOT NULL,
  `status` int(10) unsigned default NULL,
  `depend` varchar(64) collate utf8_unicode_ci default NULL,
  `sms` int(10) unsigned default NULL,
  `mail` int(10) unsigned default NULL,
  `lastchk` int(10) unsigned default NULL,
  `uptime` int(10) unsigned default NULL,
  `lost` int(10) unsigned default NULL,
  `ok` int(10) unsigned default NULL,
  `delay` smallint(5) unsigned default NULL,
  UNIQUE KEY `device` (`device`),
  KEY `device_2` (`device`(8))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `monitoring`
--

LOCK TABLES `monitoring` WRITE;
/*!40000 ALTER TABLE `monitoring` DISABLE KEYS */;
/*!40000 ALTER TABLE `monitoring` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `networks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `networks` (
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `ifname` varchar(32) collate utf8_unicode_ci default NULL,
  `ip` int(10) unsigned default NULL,
  `mask` int(10) unsigned default NULL,
  `vrfname` varchar(32) collate utf8_unicode_ci default NULL,
  `status` tinyint(3) unsigned default NULL,
  KEY `device` (`device`(8)),
  KEY `ifname` (`ifname`),
  KEY `ip` (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `networks`
--

LOCK TABLES `networks` WRITE;
/*!40000 ALTER TABLE `networks` DISABLE KEYS */;
/*!40000 ALTER TABLE `networks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nodes`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nodes` (
  `name` varchar(64) collate utf8_unicode_ci default NULL,
  `ip` int(10) unsigned default NULL,
  `mac` char(12) collate utf8_unicode_ci NOT NULL,
  `oui` varchar(32) collate utf8_unicode_ci default NULL,
  `firstseen` int(10) unsigned default NULL,
  `lastseen` int(10) unsigned default NULL,
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `ifname` varchar(32) collate utf8_unicode_ci default NULL,
  `vlanid` smallint(5) unsigned default NULL,
  `ifmetric` tinyint(3) unsigned default NULL,
  `ifupdate` int(10) unsigned default NULL,
  `ifchanges` int(10) unsigned default NULL,
  `ipupdate` int(10) unsigned default NULL,
  `ipchanges` int(10) unsigned default NULL,
  `iplost` int(10) unsigned default NULL,
  `arp` smallint(5) unsigned default NULL,
  `tcpports` varchar(64) collate utf8_unicode_ci default NULL,
  `udpports` varchar(64) collate utf8_unicode_ci default NULL,
  `os` varchar(32) collate utf8_unicode_ci default '-',
  `type` varchar(32) collate utf8_unicode_ci default '-',
  `osupdate` int(10) unsigned default '0',
  PRIMARY KEY  (`mac`),
  UNIQUE KEY `mac` (`mac`),
  KEY `name` (`name`(8)),
  KEY `ip` (`ip`),
  KEY `mac_2` (`mac`),
  KEY `vlanid` (`vlanid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nodes`
--

LOCK TABLES `nodes` WRITE;
/*!40000 ALTER TABLE `nodes` DISABLE KEYS */;
/*!40000 ALTER TABLE `nodes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stock`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stock` (
  `serial` varchar(32) collate utf8_unicode_ci default NULL,
  `type` varchar(32) collate utf8_unicode_ci default NULL,
  `user` varchar(32) collate utf8_unicode_ci default NULL,
  `time` int(10) unsigned default NULL,
  `location` varchar(255) collate utf8_unicode_ci default NULL,
  `state` tinyint(3) unsigned default NULL,
  `comment` varchar(255) collate utf8_unicode_ci default NULL,
  `lastseen` int(10) unsigned default NULL,
  `source` varchar(32) collate utf8_unicode_ci default '-',
  UNIQUE KEY `serial` (`serial`),
  KEY `serial_2` (`serial`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stock`
--

LOCK TABLES `stock` WRITE;
/*!40000 ALTER TABLE `stock` DISABLE KEYS */;
/*!40000 ALTER TABLE `stock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stolen`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stolen` (
  `name` varchar(64) collate utf8_unicode_ci default NULL,
  `ip` int(10) unsigned default NULL,
  `mac` char(12) collate utf8_unicode_ci NOT NULL default '',
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `ifname` varchar(32) collate utf8_unicode_ci default NULL,
  `who` varchar(32) collate utf8_unicode_ci default NULL,
  `time` int(10) unsigned default NULL,
  PRIMARY KEY  (`mac`),
  UNIQUE KEY `mac` (`mac`),
  KEY `mac_2` (`mac`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stolen`
--

LOCK TABLES `stolen` WRITE;
/*!40000 ALTER TABLE `stolen` DISABLE KEYS */;
/*!40000 ALTER TABLE `stolen` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system` (
  `name` varchar(32) collate utf8_unicode_ci NOT NULL,
  `value` varchar(32) collate utf8_unicode_ci default '',
  UNIQUE KEY `name` (`name`),
  KEY `name_2` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system`
--

LOCK TABLES `system` WRITE;
/*!40000 ALTER TABLE `system` DISABLE KEYS */;
INSERT INTO `system` VALUES ('nodlock','0'),('threads','0');
/*!40000 ALTER TABLE `system` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `name` varchar(32) collate utf8_unicode_ci NOT NULL,
  `password` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `groups` tinyint(3) unsigned NOT NULL default '0',
  `email` varchar(64) collate utf8_unicode_ci default NULL,
  `phone` varchar(32) collate utf8_unicode_ci default NULL,
  `time` int(10) unsigned default NULL,
  `lastseen` int(10) unsigned default NULL,
  `comment` varchar(255) collate utf8_unicode_ci default NULL,
  `language` varchar(16) collate utf8_unicode_ci NOT NULL default 'english',
  `theme` varchar(16) collate utf8_unicode_ci NOT NULL default 'default',
  `volume` tinyint(3) unsigned NOT NULL default '10',
  `columns` tinyint(3) unsigned NOT NULL default '5',
  `msglimit` tinyint(3) unsigned NOT NULL default '5',
  `graphs` tinyint(3) unsigned NOT NULL default '2',
  PRIMARY KEY  (`name`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES ('admin','21232f297a57a5a743894a0e4a801fc3',255,NULL,NULL,1297711938,NULL,'default admin','english','default',100,8,10,3);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vlans`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vlans` (
  `device` varchar(64) character set utf8 collate utf8_bin default NULL,
  `vlanid` smallint(5) unsigned default NULL,
  `vlanname` varchar(32) collate utf8_unicode_ci default NULL,
  KEY `vlanid` (`vlanid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vlans`
--

LOCK TABLES `vlans` WRITE;
/*!40000 ALTER TABLE `vlans` DISABLE KEYS */;
/*!40000 ALTER TABLE `vlans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wlan`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `wlan` (
  `mac` varchar(12) collate utf8_unicode_ci default NULL,
  `time` int(10) unsigned default NULL,
  KEY `mac` (`mac`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wlan`
--

LOCK TABLES `wlan` WRITE;
/*!40000 ALTER TABLE `wlan` DISABLE KEYS */;
INSERT INTO `wlan` VALUES ('000094d4',1297711938),('0000aabb',1297711938),('0000c5ad',1297711938),('0000c5b0',1297711938),('0000c5b2',1297711938),('0000c5b3',1297711938),('0000c5b4',1297711938),('0000c5b6',1297711938),('0000c5b7',1297711938),('0000c5ba',1297711938),('0000c5bb',1297711938),('0000c5bd',1297711938),('0000c5bf',1297711938),('0000c5c1',1297711938),('0000cb38',1297711938),('0001037c',1297711938),('000103b8',1297711938),('00012490',1297711938),('000124a0',1297711938),('000124b0',1297711938),('000124f2',1297711938),('000124f4',1297711938),('00013606',1297711938),('00013607',1297711938),('0001e301',1297711938),('0001e302',1297711938),('0001e303',1297711938),('0001e304',1297711938),('0001e305',1297711938),('0001e306',1297711938),('0001e307',1297711938),('0001e30a',1297711938),('0001e30c',1297711938),('0001e30d',1297711938),('0001e30e',1297711938),('0001e693',1297711938),('0001f475',1297711938),('00022d00',1297711938),('00022d02',1297711938),('00022d03',1297711938),('00022d05',1297711938),('00022d06',1297711938),('00022d07',1297711938),('00022d09',1297711938),('00022d0b',1297711938),('00022d0c',1297711938),('00022d0e',1297711938),('00022d14',1297711938),('00022d1d',1297711938),('00022d1e',1297711938),('00022d1f',1297711938),('00022d20',1297711938),('00022d21',1297711938),('00022d22',1297711938),('00022d25',1297711938),('00022d27',1297711938),('00022d28',1297711938),('00022d29',1297711938),('00022d2a',1297711938),('00022d2c',1297711938),('00022d2d',1297711938),('00022d2e',1297711938),('00022d2f',1297711938),('00022d30',1297711938),('00022d31',1297711938),('00022d32',1297711938),('00022d34',1297711938),('00022d37',1297711938),('00022d38',1297711938),('00022d39',1297711938),('00022d3b',1297711938),('00022d3f',1297711938),('00022d40',1297711938),('00022d41',1297711938),('00022d42',1297711938),('00022d4a',1297711938),('00022d4e',1297711938),('00022d51',1297711938),('00022d5b',1297711938),('00022d5f',1297711938),('00022d60',1297711938),('00022d61',1297711938),('00022d68',1297711938),('00022d6e',1297711938),('00022d7b',1297711938),('00022d81',1297711938),('00022d82',1297711938),('00022d88',1297711938),('00022d8b',1297711938),('00022d8d',1297711938),('00022d91',1297711938),('00022da5',1297711938),('00022db1',1297711938),('00022db4',1297711938),('00022db8',1297711938),('00022dbb',1297711938),('00022dbc',1297711938),('00022dc2',1297711938),('00026f04',1297711938),('00026f06',1297711938),('00026f07',1297711938),('00026f08',1297711938),('00026f09',1297711938),('00027200',1297711938),('00027203',1297711938),('00027204',1297711938),('00027242',1297711938),('00027243',1297711938),('00027244',1297711938),('00027245',1297711938),('00027280',1297711938),('00028a0e',1297711938),('00028a1f',1297711938),('00028a21',1297711938),('00028a5c',1297711938),('00028a77',1297711938),('00028a94',1297711938),('00028a9a',1297711938),('00028a9e',1297711938),('00028a9f',1297711938),('00028aa0',1297711938),('00028ab6',1297711938),('00028abd',1297711938),('00028adc',1297711938),('00028add',1297711938),('00028ae1',1297711938),('00028ae2',1297711938),('00028af3',1297711938),('00028afc',1297711938),('0002a52d',1297711938),('0002a52e',1297711938),('0002a56e',1297711938),('0002b304',1297711938),('0002b394',1297711938),('0002b3ba',1297711938),('0002b3c3',1297711938),('0002b3c6',1297711938),('0002b3cf',1297711938),('0002dd35',1297711938),('0002dd81',1297711938),('0002dd82',1297711938),('0002e31c',1297711938),('00031b00',1297711938),('00032f04',1297711938),('00032f05',1297711938),('00032f08',1297711938),('00032f0a',1297711938),('00032f0d',1297711938),('00032f0e',1297711938),('00032f0f',1297711938),('00032f15',1297711938),('00032f18',1297711938),('00032f20',1297711938),('000393e8',1297711938),('000393e9',1297711938),('000393ea',1297711938),('000393eb',1297711938),('000393ec',1297711938),('000393ed',1297711938),('000393ee',1297711938),('000393ef',1297711938),('00039d4d',1297711938),('00039d4f',1297711938),('00042005',1297711938),('00042348',1297711938),('00042349',1297711938),('0004234a',1297711938),('00042353',1297711938),('00042357',1297711938),('00042358',1297711938),('00042359',1297711938),('0004235d',1297711938),('0004235f',1297711938),('00042360',1297711938),('00042361',1297711938),('00042363',1297711938),('0004236c',1297711938),('0004236f',1297711938),('00042370',1297711938),('00042371',1297711938),('00042372',1297711938),('00042376',1297711938),('00042377',1297711938),('0004237a',1297711938),('0004237b',1297711938),('0004237e',1297711938),('00042381',1297711938),('00042382',1297711938),('0004238b',1297711938),('0004238f',1297711938),('00042390',1297711938),('00042394',1297711938),('00042398',1297711938),('00042399',1297711938),('000423a0',1297711938),('000423a2',1297711938),('000423a4',1297711938),('00045a0e',1297711938),('00045a0f',1297711938),('00045afd',1297711938),('00047561',1297711938),('00047562',1297711938),('00047563',1297711938),('00047564',1297711938),('000475bb',1297711938),('000475eb',1297711938),('000476a5',1297711938),('000476a6',1297711938),('0004db00',1297711938),('0004e25f',1297711938),('0004e264',1297711938),('0004e27d',1297711938),('0004e287',1297711938),('0004e288',1297711938),('0004e28b',1297711938),('0004e28c',1297711938),('0004e29a',1297711938),('0004e29b',1297711938),('0004e29d',1297711938),('0004e2a7',1297711938),('0004e2ad',1297711938),('0004e2af',1297711938),('0004e2b6',1297711938),('0004e2b8',1297711938),('0004e2b9',1297711938),('0004e2bc',1297711938),('0004e2c1',1297711938),('0004e2c2',1297711938),('0004ed04',1297711938),('0004ed05',1297711938),('0004ed06',1297711938),('00053c04',1297711938),('00053c07',1297711938),('00053c08',1297711938),('00053c09',1297711938),('00054e40',1297711938),('00054e41',1297711938),('00054e42',1297711938),('00054e43',1297711938),('00054e44',1297711938),('00054e45',1297711938),('00054e46',1297711938),('00055d08',1297711938),('00055da6',1297711938),('00055da7',1297711938),('00055dd6',1297711938),('00055dda',1297711938),('00055dea',1297711938),('00055deb',1297711938),('00055ded',1297711938),('00055dee',1297711938),('00055df1',1297711938),('00055df2',1297711938),('00056530',1297711938),('0005b406',1297711938),('0006250f',1297711938),('00062513',1297711938),('0006254a',1297711938),('0006254b',1297711938),('00062550',1297711938),('00062553',1297711938),('00062557',1297711938),('00062564',1297711938),('00062576',1297711938),('0006257b',1297711938),('0006257f',1297711938),('00062586',1297711938),('0006258d',1297711938),('00062597',1297711938),('0006259b',1297711938),('000625a1',1297711938),('000625a4',1297711938),('000625b4',1297711938),('000625b5',1297711938),('000625bf',1297711938),('000625c0',1297711938),('000625c3',1297711938),('000625c4',1297711938),('000625c5',1297711938),('000625d7',1297711938),('000625d9',1297711938),('000625e8',1297711938),('000625ea',1297711938),('000625f0',1297711938),('000625ff',1297711938),('0006ab00',1297711938),('0006b141',1297711938),('0006f400',1297711938),('0006f401',1297711938),('0006f402',1297711938),('00070eb3',1297711938),('0007404d',1297711938),('0007404e',1297711938),('00074057',1297711938),('00074076',1297711938),('00074077',1297711938),('0007408b',1297711938),('0007409f',1297711938),('000740a0',1297711938),('000740b1',1297711938),('000740c4',1297711938),('000740d8',1297711938),('000740da',1297711938),('000740e8',1297711938),('000740ed',1297711938),('000740f2',1297711938),('000750cb',1297711938),('000750d5',1297711938),('000750d6',1297711938),('00078592',1297711938),('000785b3',1297711938),('000785b4',1297711938),('0007ca00',1297711938),('0007ca01',1297711938),('0007ca02',1297711938),('0007eb30',1297711938),('0007ef03',1297711938),('000802d2',1297711938),('000802f6',1297711938),('00082131',1297711938),('0008a142',1297711938),('0008a16a',1297711938),('000943ad',1297711938),('00095b0c',1297711938),('00095b28',1297711938),('00095b2b',1297711938),('00095b2c',1297711938),('00095b2d',1297711938),('00095b2f',1297711938),('00095b30',1297711938),('00095b34',1297711938),('00095b35',1297711938),('00095b36',1297711938),('00095b37',1297711938),('00095b3a',1297711938),('00095b3b',1297711938),('00095b3c',1297711938),('00095b3e',1297711938),('00095b41',1297711938),('00095b42',1297711938),('00095b43',1297711938),('00095b45',1297711938),('00095b46',1297711938),('00095b48',1297711938),('00095b4d',1297711938),('00095b4e',1297711938),('00095b4f',1297711938),('00095b50',1297711938),('00095b52',1297711938),('00095b53',1297711938),('00095b57',1297711938),('00095b5a',1297711938),('00095b5b',1297711938),('00095b5c',1297711938),('00095b5d',1297711938),('00095b5e',1297711938),('00095b64',1297711938),('00095b66',1297711938),('00095b67',1297711938),('00095b68',1297711938),('00095b69',1297711938),('00095b6b',1297711938),('00095b6c',1297711938),('00095b6d',1297711938),('00095b6e',1297711938),('00095b6f',1297711938),('00095b71',1297711938),('00095b72',1297711938),('00095b73',1297711938),('00095b84',1297711938),('00095b86',1297711938),('00095b87',1297711938),('00095b88',1297711938),('00095b89',1297711938),('00095b90',1297711938),('00095b91',1297711938),('00095b93',1297711938),('00095b95',1297711938),('00095b96',1297711938),('00095b97',1297711938),('00095b98',1297711938),('00095b99',1297711938),('00095b9b',1297711938),('00095b9c',1297711938),('00095b9e',1297711938),('00095ba2',1297711938),('00095ba3',1297711938),('00095ba8',1297711938),('00095ba9',1297711938),('00095bad',1297711938),('00095bae',1297711938),('00095baf',1297711938),('00095bb1',1297711938),('00095bb7',1297711938),('00095bbb',1297711938),('00095bbc',1297711938),('00095bc1',1297711938),('00095bc2',1297711938),('00095bc3',1297711938),('00095bc4',1297711938),('00095bc5',1297711938),('00095bc6',1297711938),('00095bc7',1297711938),('00095bc8',1297711938),('00095bc9',1297711938),('00095bca',1297711938),('00095bcb',1297711938),('00095bcc',1297711938),('00095bce',1297711938),('00095bcf',1297711938),('00095bd0',1297711938),('00095bd1',1297711938),('00095bd5',1297711938),('00095bd6',1297711938),('00095bd7',1297711938),('00095bd9',1297711938),('00095bda',1297711938),('00095bdb',1297711938),('00095bdc',1297711938),('00095bdd',1297711938),('00095bde',1297711938),('00095bdf',1297711938),('00095be7',1297711938),('00095beb',1297711938),('00095bf6',1297711938),('00095bf7',1297711938),('00095bfb',1297711938),('00095bfe',1297711938),('00095bff',1297711938),('00097c49',1297711938),('00097c9f',1297711938),('00097cd1',1297711938),('00099200',1297711938),('0009b72d',1297711938),('0009b73c',1297711938),('0009b746',1297711938),('0009b756',1297711938),('0009b77b',1297711938),('0009b7bf',1297711938),('0009e8b5',1297711938),('0009f306',1297711938),('000a0498',1297711938),('000a0499',1297711938),('000a4104',1297711938),('000a417d',1297711938),('000a41ee',1297711938),('000a5e08',1297711938),('000a7919',1297711938),('000a7931',1297711938),('000a7936',1297711938),('000a8a47',1297711938),('000a8a5f',1297711938),('000a95f1',1297711938),('000a95f2',1297711938),('000a95f3',1297711938),('000a95f4',1297711938),('000a95f5',1297711938),('000a95f6',1297711938),('000a95f7',1297711938),('000a95f8',1297711938),('000ab701',1297711938),('000ab7af',1297711938),('000ab7bb',1297711938),('000b0666',1297711938),('000b4603',1297711938),('000b5f19',1297711938),('000b5f3f',1297711938),('000b5f55',1297711938),('000b5f6e',1297711938),('000b5fea',1297711938),('000b6b30',1297711938),('000b6b49',1297711938),('000b6b4a',1297711938),('000b8509',1297711938),('000bace5',1297711938),('000bace6',1297711938),('000bace7',1297711938),('000bbef0',1297711938),('000bbef8',1297711938),('000bcd5d',1297711938),('000bfd01',1297711938),('000bfd0a',1297711938),('000bfd30',1297711938),('000bfd60',1297711938),('000bfdcd',1297711938),('000bfdf3',1297711938),('000c3008',1297711938),('000c3014',1297711938),('000c303c',1297711938),('000c305b',1297711938),('000c30da',1297711938),('000c4112',1297711938),('000c4114',1297711938),('000c4117',1297711938),('000c4118',1297711938),('000c4119',1297711938),('000c4133',1297711938),('000c4136',1297711938),('000c4138',1297711938),('000c413a',1297711938),('000c4163',1297711938),('000c4165',1297711938),('000c417b',1297711938),('000c417e',1297711938),('000c4187',1297711938),('000c4196',1297711938),('000c419d',1297711938),('000c41a5',1297711938),('000c41aa',1297711938),('000c41b3',1297711938),('000c41b6',1297711938),('000c41bf',1297711938),('000c41c8',1297711938),('000c41d5',1297711938),('000c41d7',1297711938),('000c41d8',1297711938),('000c41de',1297711938),('000c41e3',1297711938),('000c41e4',1297711938),('000c41f6',1297711938),('000c41f9',1297711938),('000c41fa',1297711938),('000c6ec1',1297711938),('000c6ed4',1297711938),('000c7671',1297711938),('000c850e',1297711938),('000c8576',1297711938),('000c85c0',1297711938),('000cce14',1297711938),('000cce1d',1297711938),('000cce21',1297711938),('000cce33',1297711938),('000cce60',1297711938),('000cce91',1297711938),('000cce93',1297711938),('000cceff',1297711938),('000ce546',1297711938),('000cf100',1297711938),('000cf101',1297711938),('000cf102',1297711938),('000cf103',1297711938),('000cf104',1297711938),('000cf10a',1297711938),('000cf10d',1297711938),('000cf10f',1297711938),('000cf110',1297711938),('000cf112',1297711938),('000cf114',1297711938),('000cf115',1297711938),('000cf118',1297711938),('000cf119',1297711938),('000cf121',1297711938),('000cf124',1297711938),('000cf125',1297711938),('000cf126',1297711938),('000cf129',1297711938),('000cf12f',1297711938),('000cf131',1297711938),('000cf134',1297711938),('000cf135',1297711938),('000cf136',1297711938),('000cf139',1297711938),('000cf13c',1297711938),('000cf13e',1297711938),('000cf13f',1297711938),('000cf142',1297711938),('000cf145',1297711938),('000cf146',1297711938),('000cf14a',1297711938),('000cf601',1297711938),('000cf608',1297711938),('000d0b1a',1297711938),('000d282e',1297711938),('000d283e',1297711938),('000d283f',1297711938),('000d2868',1297711938),('000d2877',1297711938),('000d2888',1297711938),('000d288e',1297711938),('000d291d',1297711938),('000d2928',1297711938),('000d292e',1297711938),('000d294a',1297711938),('000d294f',1297711938),('000d2962',1297711938),('000d29ac',1297711938),('000d29f0',1297711938),('000d3a2a',1297711938),('000d5499',1297711938),('000d549a',1297711938),('000d549b',1297711938),('000d549c',1297711938),('000d549d',1297711938),('000d549e',1297711938),('000d54a0',1297711938),('000d54a2',1297711938),('000d54a3',1297711938),('000d54a8',1297711938),('000d54a9',1297711938),('000d54aa',1297711938),('000d54f7',1297711938),('000d54f8',1297711938),('000d6536',1297711938),('000d6543',1297711938),('000d6572',1297711938),('000d659b',1297711938),('000d65bb',1297711938),('000d65e9',1297711938),('000d724b',1297711938),('000d727a',1297711938),('000d7281',1297711938),('000d7299',1297711938),('000d8806',1297711938),('000d8807',1297711938),('000d881d',1297711938),('000d882b',1297711938),('000d8833',1297711938),('000d883a',1297711938),('000d883b',1297711938),('000d883e',1297711938),('000d883f',1297711938),('000d8855',1297711938),('000d8856',1297711938),('000d8881',1297711938),('000d8882',1297711938),('000d8884',1297711938),('000d8885',1297711938),('000d8886',1297711938),('000d8887',1297711938),('000d888c',1297711938),('000d888d',1297711938),('000d888e',1297711938),('000d8891',1297711938),('000d8892',1297711938),('000d8893',1297711938),('000d8894',1297711938),('000d8895',1297711938),('000d8898',1297711938),('000d8899',1297711938),('000d889a',1297711938),('000d889b',1297711938),('000d889d',1297711938),('000d88a0',1297711938),('000d88a1',1297711938),('000d88a3',1297711938),('000d88a4',1297711938),('000d88a6',1297711938),('000d88ab',1297711938),('000d88ad',1297711938),('000d88ae',1297711938),('000d88b9',1297711938),('000d88bc',1297711938),('000d88bd',1297711938),('000d88c1',1297711938),('000d88c3',1297711938),('000d88c4',1297711938),('000d88c8',1297711938),('000d88c9',1297711938),('000d88e1',1297711938),('000d88e7',1297711938),('000d88e9',1297711938),('000d88ea',1297711938),('000d88eb',1297711938),('000d88ec',1297711938),('000d88f3',1297711938),('000d937d',1297711938),('000d937e',1297711938),('000d937f',1297711938),('000d9380',1297711938),('000d9381',1297711938),('000d9383',1297711938),('000d9384',1297711938),('000d9386',1297711938),('000d9387',1297711938),('000d9389',1297711938),('000d938a',1297711938),('000d938b',1297711938),('000d93ea',1297711938),('000d93eb',1297711938),('000d93ec',1297711938),('000d93ed',1297711938),('000d93ef',1297711938),('000d93f0',1297711938),('000d9dc7',1297711938),('000dbc25',1297711938),('000dbc50',1297711938),('000dbc68',1297711938),('000dbd01',1297711938),('000dbd33',1297711938),('000dbdd0',1297711938),('000dbdd6',1297711938),('000dbdda',1297711938),('000ded2e',1297711938),('000ded4d',1297711938),('000ded77',1297711938),('000ded87',1297711938),('000ded90',1297711938),('000ded96',1297711938),('000ded97',1297711938),('000dedc2',1297711938),('000dedd0',1297711938),('000deded',1297711938),('000e3508',1297711938),('000e350a',1297711938),('000e350e',1297711938),('000e3511',1297711938),('000e3516',1297711938),('000e351d',1297711938),('000e351f',1297711938),('000e3520',1297711938),('000e3521',1297711938),('000e3525',1297711938),('000e3529',1297711938),('000e3532',1297711938),('000e3534',1297711938),('000e353b',1297711938),('000e3540',1297711938),('000e3546',1297711938),('000e3547',1297711938),('000e354b',1297711938),('000e3553',1297711938),('000e355d',1297711938),('000e3563',1297711938),('000e3564',1297711938),('000e3575',1297711938),('000e3817',1297711938),('000e383b',1297711938),('000e3871',1297711938),('000e3878',1297711938),('000e38d5',1297711938),('000e38e6',1297711938),('000e6a7b',1297711938),('000e831a',1297711938),('000e8360',1297711938),('000e837b',1297711938),('000e8388',1297711938),('000e83b6',1297711938),('000e844b',1297711938),('000e8483',1297711938),('000e84c2',1297711938),('000e8e7a',1297711938),('000e9b00',1297711938),('000e9b01',1297711938),('000e9b02',1297711938),('000ea663',1297711938),('000ea66a',1297711938),('000ea690',1297711938),('000ea69f',1297711938),('000ea6a1',1297711938),('000ea6b7',1297711938),('000ea6c0',1297711938),('000ed748',1297711938),('000ed7ca',1297711938),('000f2094',1297711938),('000f2371',1297711938),('000f244e',1297711938),('000f24a3',1297711938),('000f24cc',1297711938),('000f3446',1297711938),('000f347f',1297711938),('000f34ed',1297711938),('000f34ee',1297711938),('000f3d00',1297711938),('000f3d02',1297711938),('000f3d05',1297711938),('000f3d09',1297711938),('000f3d0a',1297711938),('000f3d0b',1297711938),('000f3d34',1297711938),('000f3d38',1297711938),('000f3d39',1297711938),('000f3d3b',1297711938),('000f3d3c',1297711938),('000f3d3d',1297711938),('000f3d3e',1297711938),('000f3d3f',1297711938),('000f3d42',1297711938),('000f3d47',1297711938),('000f3d4c',1297711938),('000f3d5a',1297711938),('000f3d5b',1297711938),('000f3d5c',1297711938),('000f3d5e',1297711938),('000f3d65',1297711938),('000f3d97',1297711938),('000f3d98',1297711938),('000f3d9a',1297711938),('000f3d9f',1297711938),('000f3dab',1297711938),('000f3dac',1297711938),('000f3dcf',1297711938),('000f3ddf',1297711938),('000f3de0',1297711938),('000f6603',1297711938),('000f6610',1297711938),('000f6611',1297711938),('000f6612',1297711938),('000f661a',1297711938),('000f6624',1297711938),('000f662c',1297711938),('000f6631',1297711938),('000f664b',1297711938),('000f664c',1297711938),('000f664d',1297711938),('000f6651',1297711938),('000f6654',1297711938),('000f6655',1297711938),('000f6656',1297711938),('000f6657',1297711938),('000f6659',1297711938),('000f665b',1297711938),('000f6690',1297711938),('000f6697',1297711938),('000f66a2',1297711938),('000f66a3',1297711938),('000f66a7',1297711938),('000f66c2',1297711938),('000f66c7',1297711938),('000f66d3',1297711938),('000f66db',1297711938),('000f8f20',1297711938),('000f8f28',1297711938),('000f8f2b',1297711938),('000f8f31',1297711938),('000f8f35',1297711938),('000f90ac',1297711938),('000f90f3',1297711938),('000fb504',1297711938),('000fb50c',1297711938),('000fb50d',1297711938),('000fb50f',1297711938),('000fb512',1297711938),('000fb514',1297711938),('000fb515',1297711938),('000fb516',1297711938),('000fb51e',1297711938),('000fcc00',1297711938),('000fcc01',1297711938),('000ff700',1297711938),('000ff701',1297711938),('000ff703',1297711938),('000ff748',1297711938),('000ff77a',1297711938),('000ff7eb',1297711938),('000ff7f9',1297711938),('0010608c',1297711938),('00109100',1297711938),('0010a729',1297711938),('0010c621',1297711938),('0010e7f5',1297711938),('001120b4',1297711938),('001120c2',1297711938),('00112176',1297711938),('001121ce',1297711938),('00112400',1297711938),('00112401',1297711938),('00112402',1297711938),('00112403',1297711938),('00112404',1297711938),('00112405',1297711938),('00112406',1297711938),('00112407',1297711938),('00112408',1297711938),('00112409',1297711938),('00115c1b',1297711938),('00115c34',1297711938),('00115c37',1297711938),('00115c68',1297711938),('001192f6',1297711938),('00119500',1297711938),('00119501',1297711938),('00119509',1297711938),('00121724',1297711938),('0016b6dd',1297711938),('0020a64e',1297711938),('0020a64f',1297711938),('0020e013',1297711938),('0020e04d',1297711938),('0020e089',1297711938),('0020e08a',1297711938),('0020e08c',1297711938),('0020e08d',1297711938),('0020e08e',1297711938),('00304f21',1297711938),('00304f24',1297711938),('00304f26',1297711938),('00304f28',1297711938),('00304f29',1297711938),('00304f2a',1297711938),('00304f2b',1297711938),('00304f2c',1297711938),('00304f2f',1297711938),('00304f36',1297711938),('00306500',1297711938),('00306502',1297711938),('00306503',1297711938),('00306504',1297711938),('00306505',1297711938),('00306506',1297711938),('00306507',1297711938),('00306509',1297711938),('0030650a',1297711938),('0030650b',1297711938),('0030650d',1297711938),('00306510',1297711938),('00306512',1297711938),('00306514',1297711938),('00306515',1297711938),('00306516',1297711938),('00306517',1297711938),('0030651a',1297711938),('0030651b',1297711938),('0030651d',1297711938),('0030651e',1297711938),('0030651f',1297711938),('00306521',1297711938),('00306524',1297711938),('00306528',1297711938),('00306e0d',1297711938),('0030ab09',1297711938),('0030ab0a',1297711938),('0030ab0c',1297711938),('0030ab0e',1297711938),('0030ab10',1297711938),('0030ab14',1297711938),('0030ab15',1297711938),('0030ab16',1297711938),('0030ab17',1297711938),('0030ab19',1297711938),('0030ab1a',1297711938),('0030ab1b',1297711938),('0030ab1e',1297711938),('0030ab1f',1297711938),('0030ab20',1297711938),('0030ab21',1297711938),('0030ab22',1297711938),('0030ab23',1297711938),('0030bd60',1297711938),('0030bd61',1297711938),('0030bd93',1297711938),('0030bd94',1297711938),('0030bd95',1297711938),('0030bd96',1297711938),('0030bd9d',1297711938),('0030bdfb',1297711938),('0030f177',1297711938),('00400524',1297711938),('00400526',1297711938),('00400528',1297711938),('0040052a',1297711938),('00400530',1297711938),('00400531',1297711938),('00400548',1297711938),('00400549',1297711938),('00400552',1297711938),('00400553',1297711938),('00400555',1297711938),('00400556',1297711938),('0040055a',1297711938),('0040055b',1297711938),('0040055d',1297711938),('0040055e',1297711938),('004005af',1297711938),('004005bc',1297711938),('004005be',1297711938),('004005c0',1297711938),('004005c2',1297711938),('004005c5',1297711938),('004005c7',1297711938),('004005c8',1297711938),('004005ca',1297711938),('004005cb',1297711938),('004005cc',1297711938),('004005d0',1297711938),('00409625',1297711938),('00409626',1297711938),('00409627',1297711938),('00409629',1297711938),('00409630',1297711938),('00409633',1297711938),('00409634',1297711938),('00409635',1297711938),('00409636',1297711938),('00409637',1297711938),('00409638',1297711938),('00409639',1297711938),('00409640',1297711938),('00409641',1297711938),('00409642',1297711938),('00409643',1297711938),('00409644',1297711938),('00409645',1297711938),('00409646',1297711938),('00409647',1297711938),('00409648',1297711938),('00409649',1297711938),('00409651',1297711938),('00409652',1297711938),('00409653',1297711938),('00409654',1297711938),('00409655',1297711938),('00409656',1297711938),('00409657',1297711938),('00409658',1297711938),('00409659',1297711938),('0040965a',1297711938),('0040965b',1297711938),('0040965c',1297711938),('0040965d',1297711938),('0040965e',1297711938),('004096a0',1297711938),('004096a1',1297711938),('0040c1f0',1297711938),('0040f495',1297711938),('0040f49e',1297711938),('0040f4aa',1297711938),('00501805',1297711938),('00501807',1297711938),('00501811',1297711938),('00501813',1297711938),('00501815',1297711938),('00501816',1297711938),('00501821',1297711938),('00501825',1297711938),('00501828',1297711938),('0050182a',1297711938),('0050182b',1297711938),('0050182c',1297711938),('00508b99',1297711938),('0050da01',1297711938),('0050da92',1297711938),('0050da95',1297711938),('0050da96',1297711938),('0050daf5',1297711938),('0050f273',1297711938),('0050fcba',1297711938),('0050fcd1',1297711938),('0050fcd4',1297711938),('0050fcd5',1297711938),('00601d03',1297711938),('00601d1c',1297711938),('00601d1e',1297711938),('00601d1f',1297711938),('00601d22',1297711938),('00601d23',1297711938),('00601df0',1297711938),('00601df1',1297711938),('00601df2',1297711938),('00601df6',1297711938),('00601df7',1297711938),('0060b301',1297711938),('0060b306',1297711938),('0060b313',1297711938),('0060b316',1297711938),('0060b317',1297711938),('0060b318',1297711938),('0060b31c',1297711938),('0060b31e',1297711938),('0060b31f',1297711938),('0060b366',1297711938),('0060b367',1297711938),('0060b371',1297711938),('0060b374',1297711938),('0060b375',1297711938),('0060b378',1297711938),('0060b380',1297711938),('0060b38b',1297711938),('0060b391',1297711938),('0060b399',1297711938),('0060b3a3',1297711938),('0080c6e4',1297711938),('0080c6e5',1297711938),('0080c800',1297711938),('0080c802',1297711938),('0080c803',1297711938),('0080c806',1297711938),('0080c807',1297711938),('0080c809',1297711938),('0080c80b',1297711938),('0080c812',1297711938),('0080c813',1297711938),('0080c814',1297711938),('0080c815',1297711938),('0080c817',1297711938),('0080c81e',1297711938),('0080c823',1297711938),('0080c824',1297711938),('0080c829',1297711938),('0080c82a',1297711938),('0080c82d',1297711938),('0080c837',1297711938),('0080c838',1297711938),('0080c8aa',1297711938),('0080c8ab',1297711938),('0080c8ac',1297711938),('0080c8ad',1297711938),('0080c8af',1297711938),('0080c8b0',1297711938),('0080c8b5',1297711938),('0080c8b6',1297711938),('0080c8b7',1297711938),('0080c8b8',1297711938),('00900e00',1297711938),('00904b0b',1297711938),('00904b14',1297711938),('00904b17',1297711938),('00904b19',1297711938),('00904b1e',1297711938),('00904b22',1297711938),('00904b24',1297711938),('00904b27',1297711938),('00904b29',1297711938),('00904b2b',1297711938),('00904b2f',1297711938),('00904b31',1297711938),('00904b33',1297711938),('00904b35',1297711938),('00904b36',1297711938),('00904b37',1297711938),('00904b38',1297711938),('00904b39',1297711938),('00904b3c',1297711938),('00904b3d',1297711938),('00904b4b',1297711938),('00904b4d',1297711938),('00904b5d',1297711938),('00904b65',1297711938),('00904b6c',1297711938),('00904b6d',1297711938),('00904b74',1297711938),('00904b8e',1297711938),('00904ba0',1297711938),('00907a00',1297711938),('0090963e',1297711938),('00909640',1297711938),('00909644',1297711938),('00909654',1297711938),('0090966a',1297711938),('009096b4',1297711938),('009096c0',1297711938),('009096c1',1297711938),('0090d001',1297711938),('0090d100',1297711938),('0090d101',1297711938),('00a0c500',1297711938),('00a0c529',1297711938),('00a0c533',1297711938),('00a0c534',1297711938),('00a0c536',1297711938),('00a0c537',1297711938),('00a0c538',1297711938),('00a0c539',1297711938),('00a0c53a',1297711938),('00a0c53c',1297711938),('00a0c53e',1297711938),('00a0c53f',1297711938),('00a0c540',1297711938),('00a0c541',1297711938),('00a0c543',1297711938),('00a0c544',1297711938),('00a0c546',1297711938),('00a0c54d',1297711938),('00a0c54e',1297711938),('00a0c550',1297711938),('00a0c552',1297711938),('00a0c555',1297711938),('00a0c557',1297711938),('00a0c558',1297711938),('00a0c559',1297711938),('00a0c55a',1297711938),('00a0c55b',1297711938),('00a0c55c',1297711938),('00a0c55d',1297711938),('00a0c55e',1297711938),('00a0c55f',1297711938),('00a0c560',1297711938),('00a0c561',1297711938),('00a0c562',1297711938),('00a0c563',1297711938),('00a0c564',1297711938),('00a0c565',1297711938),('00a0c566',1297711938),('00a0c567',1297711938),('00a0c568',1297711938),('00a0c569',1297711938),('00a0c56a',1297711938),('00a0c56b',1297711938),('00a0c56c',1297711938),('00a0c56d',1297711938),('00a0c56e',1297711938),('00a0c56f',1297711938),('00a0c570',1297711938),('00a0c571',1297711938),('00a0c572',1297711938),('00a0c575',1297711938),('00a0c576',1297711938),('00a0c578',1297711938),('00a0c579',1297711938),('00a0c57f',1297711938),('00a0c580',1297711938),('00a0c581',1297711938),('00a0c582',1297711938),('00a0c58c',1297711938),('00a0c58d',1297711938),('00a0c58e',1297711938),('00a0c58f',1297711938),('00a0c590',1297711938),('00a0c591',1297711938),('00a0c592',1297711938),('00a0c59a',1297711938),('00a0c59c',1297711938),('00a0c59d',1297711938),('00a0c59e',1297711938),('00a0c5b0',1297711938),('00a0c5b1',1297711938),('00a0c5b5',1297711938),('00a0c5b6',1297711938),('00a0c5b7',1297711938),('00a0c5ed',1297711938),('00a0c5ee',1297711938),('00a0c5f3',1297711938),('00a0de1b',1297711938),('00a0f835',1297711938),('00a0f843',1297711938),('00a0f844',1297711938),('00a0f848',1297711938),('00a0f84b',1297711938),('00a0f84d',1297711938),('00a0f84f',1297711938),('00a0f851',1297711938),('00a0f852',1297711938),('00a0f855',1297711938),('00a0f856',1297711938),('00a0f85c',1297711938),('00a0f85d',1297711938),('00a0f861',1297711938),('00a0f88d',1297711938),('00a0f894',1297711938),('00a0f89c',1297711938),('00a0f8a5',1297711938),('00a0f8a6',1297711938),('00a0f8ab',1297711938),('00a0f8ac',1297711938),('00a0f8b1',1297711938),('00abcdab',1297711938),('00c00248',1297711938),('00c002da',1297711938),('00c002df',1297711938),('00c002ea',1297711938),('00c002eb',1297711938),('00c002ef',1297711938),('00c002fa',1297711938),('00c002fb',1297711938),('00c002fc',1297711938),('00c002fd',1297711938),('00c04952',1297711938),('00c04953',1297711938),('00c049a6',1297711938),('00c049a8',1297711938),('00c049a9',1297711938),('00c049b0',1297711938),('00c049cc',1297711938),('00c049d3',1297711938),('00c049d4',1297711938),('00c049d7',1297711938),('00c049d8',1297711938),('00c049d9',1297711938),('00c049da',1297711938),('00c049de',1297711938),('00c049e0',1297711938),('00c049e1',1297711938),('00c049e2',1297711938),('00c049e4',1297711938),('00c049e5',1297711938),('00c049e6',1297711938),('00c049e7',1297711938),('00c049e8',1297711938),('00c049ec',1297711938),('00c049ed',1297711938),('00c049ee',1297711938),('00c049ef',1297711938),('00d059bc',1297711938),('00d059d3',1297711938),('00d09e43',1297711938),('00e00089',1297711938),('00e06350',1297711938),('0200069d',1297711938),('020008ab',1297711938),('02001e73',1297711938),('02002e88',1297711938),('02004156',1297711938),('02006511',1297711938),('020068e9',1297711938),('0200759e',1297711938),('02008033',1297711938),('02008293',1297711938),('020085e1',1297711938),('02009087',1297711938),('0200a958',1297711938),('0200af19',1297711938),('0200b82e',1297711938),('0200d898',1297711938),('0200d94a',1297711938),('0200da6e',1297711938),('0200e068',1297711938),('0200ee71',1297711938),('0200f921',1297711938),('02020200',1297711938),('02022d2b',1297711938),('02022d66',1297711938),('02042336',1297711938),('02042355',1297711938),('020b6b30',1297711938),('020cf100',1297711938),('020cf147',1297711938),('020e3500',1297711938),('0225b642',1297711938),('02601a8e',1297711938),('0260d61c',1297711938),('0260e5d0',1297711938),('027e3619',1297711938),('029022ff',1297711938),('02c0eb07',1297711938);
/*!40000 ALTER TABLE `wlan` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2011-02-14 17:33:34
