<?
/*
#============================================================================
# Program: Reports-Modules.php
# Programmer: Remo Rickli
#
# DATE		COMMENT
# -----------------------------------------------------------
# 26/06/06	initial version
# 03/07/07	minor changes & new inventory
# 04/09/07	implemented CSS scheme
# 20/09/07	implemented language support
# 24/06/08	fixed ccc support (provided by Andreas Wassatsch)
*/

error_reporting(E_ALL ^ E_NOTICE);

include_once ("inc/header.php");
include_once ('inc/libdev.php');

$_GET = sanitize($_GET);
$rep = isset($_GET['rep']) ? $_GET['rep'] : array();
$flt = isset($_GET['flt']) ? $_GET['flt'] : "";
$ord = isset($_GET['ord']) ? "checked" : "";
?>
<h1>Module Reports</h1>
<form method="get" action="<?=$self?>.php">
<table class="content"><tr class="<?=$modgroup[$self]?>1">
<th width=80><a href="<?=$self?>.php"><img src="img/32/<?=$selfi?>.png"></a></th>
<th><?=$sellbl?></th>
<th>
<SELECT MULTIPLE name="rep[]" size="4">
<OPTION VALUE="sum" <?=(in_array("sum",$rep))?"selected":""?> ><?=$sumlbl?>
<OPTION VALUE="inv" <?=(in_array("inv",$rep))?"selected":""?> >Inventory
<option value="prt" <? if(in_array("prt",$rep)){echo "selected";} ?> >Print Supplies
<?
$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
$tquery = GenQuery("cisco_contracts", "t");
$res    = DbQuery($tquery, $link);
if( DbFetchRow($res) ){								# Show item only, if cisco_contracts table exists
?>
<OPTION VALUE="ves" <?=(in_array("ves",$rep))?"selected":""?> ><?=$venlbl?> <?=$stalbl?>
<?}?>
</SELECT>
</th>
<th>Filter
<input type="text" name="flt" value="<?=$flt?>" size="20" title="Filter module-models or device-types">
</th>
</th>
<th>
<INPUT type="checkbox" name="ord"  <?=$ord?> title="Sort by model or type"> <?=$altlbl?>
</th>
</SELECT></th>
<th width="80"><input type="submit" name="do" value="<?=$shobtn?>"></th>
</tr></table></form><p>
<?
if ( in_array("sum",$rep) ){
?>
<h2>Model <?=$sumlbl?></h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width="80"><img src="img/32/abc.png"><br>Model</th>
<th><img src="img/32/find.png"><br><?=$deslbl?></th>
<th><img src="img/32/dev.png"><br>Devices</th>
<th width="80"><img src="img/32/pcm.png"><br>Total</th>
<?
	$query	= GenQuery('modules','g','model,description,device','model','',array("model","description"),array('!=','regexp'),array('Printsupply',$flt),array('AND') );
	$res	= @DbQuery($query,$link);
	if($res){
		$nmod = 0;
		$nummo	= array();
		while( ($m = @DbFetchRow($res)) ){
			$nummo["$m[0];;$m[1]"] += $m[3];
			$modev["$m[0];;$m[1]"][$m[2]] = $m[3];
			$nmod += $m[3];
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
		die;
	}
	if($ord){
		ksort($nummo);
	}else{
		arsort($nummo);
	}
	$row = 0;
	foreach ($nummo as $key => $n){
		list($mdl, $desc) = split(";;", $key);
		if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
		$row++;
		$tbar = Bar($n,0);
		$um = rawurlencode($mdl);
		echo "<tr class=\"$bg\"><th class=\"$bi\">\n";
		echo "<a href=Devices-Modules.php?ina=model&opa==&sta=$um><b>$mdl</b></a></th>\n";
		echo "<td>$desc</td><td>";
		foreach ($modev["$mdl;;$desc"] as $dv => $ndv){
			$ud = rawurlencode($dv);
			echo "<a href=Devices-Status.php?dev=$ud>$dv</a>:<b>$ndv</b> ";
		}
		echo "</td>\n";
		echo "<td nowrap>$tbar $n</td></tr>\n";
		if($row == $lim){break;}
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$nmod?> modules, <?=$row?>  <?=$typlbl?></td></tr>
</table>
	<?
}

if ( in_array("inv",$rep) ){
?>
<h2>Inventory <?=($flt) ? " on \"$flt\" devices":"";?></h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th colspan=2><img src="img/32/dev.png"><br>Device / Slot</th>
<th><img src="img/32/find.png"><br>Info</th>
<th><img src="img/32/key.png"><br><?=$serlbl?></th>
<th><img src="img/32/cinf.png"><br>HW</th>
<th><img src="img/32/cog.png"><br>FW</th>
<th><img src="img/32/cbox.png"><br>SW</th>
<?
	if($ord){
		$sort = "type";
	}else{
		$sort = "name";
	}
	$query	= GenQuery('devices','s','name,type,serial,os,bootimage',$sort,'',array('os','type'),array('!=','regexp'),array('Printer',$flt) );
	$res	= @DbQuery($query,$link);
	if($res){
		$dev = 0;
		$row = 0;
		while( $d = @DbFetchRow($res) ){
			$dev++;
			$ud = rawurlencode($d[0]);
			echo "<tr class=\"imgb\"><th>\n";
			echo "<a href=\"Devices-Status.php?dev=$ud\"><b>$d[0]</b></a></th>\n";
			echo "<td>-</td><td><b>$d[1]</b></td><td>$d[2]</td><td>-</td><td>$d[3]</td><td>$d[4]</td></tr>\n";
			$mquery	= GenQuery('modules','s','*','slot','',array('device'),array('='),array($d[0]));
			$mres	= @DbQuery($mquery,$link);
			if($mres){
				while( ($m = @DbFetchRow($mres)) ){
					if ($row % 2){$bg = "txta";}else{$bg = "txtb";}
					$row++;
					echo "<tr class=\"$bg\"><th>\n";
					echo "<td  class=\"blu\">$m[1]</td><td><b>$m[2]</b> $m[3]</td><td>$m[4]</td><td>$m[5]</td><td>$m[6]</td><td>$m[7]</td></tr>\n";
				}
				@DbFreeResult($mres);
			}else{
				print @DbError($link);
				die;
			}
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
		die;
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$dev?> devices, <?=$row?> modules</td></tr>
</table>
	<?
}

if ( in_array("prt",$rep) ){
?>
<h2>Printer Supplies</h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width="33%"><img src="img/dev/pgan.png"><br>Printer</th>
<th colspan="3"><img src="img/32/file.png"><br>Supplies</th>
<?
	$ntyp = 0;
	if($ord){
		$query	= GenQuery('modules','s','*','description','',array('model','description'),array('=','regexp'),array('Printsupply',$flt),array('AND') );
	}else{
		$query	= GenQuery('modules','s','*','abs(hw)','',array('model','description'),array('=','regexp'),array('Printsupply',$flt),array('AND') );
	}
	$row = 0;
	$res	= @DbQuery($query,$link);
	if($res){
		$row = 0;
		while( $m = @DbFetchRow($res) ){
			if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
			$row++;
			$ud = rawurlencode($m[0]);
			echo "<tr class=\"$bg\"><th>\n";
			echo "<a href=\"Devices-Status.php?dev=$ud\"><b>$m[0]</b></a></th>\n";
			echo "<th class=\"$bi\">".PrintSupply($m[1])."</th>\n";
			echo "<td>$m[3]</td><td>".Bar($m[5],-33)." $m[5]%</td></tr>\n";
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
		die;
	}
	?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$dev?> devices, <?=$row?> modules</td></tr>
</table>
	<?
}

// added for Cisco contract check by Andreas Wassatsch
if ( in_array("ves",$rep) ){
?>
<h2>Inventory <?=($flt) ? " on \"$flt\" devices":"";?></h2>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th colspan=2><img src="img/32/dev.png"><br>Device / Slot</th>
<th><img src="img/32/find.png"><br>Info</th>
<th><img src="img/32/form.png"><br><?=$serlbl?></th>
<th><img src="img/32/idea.png"><br><?=$stalbl?></th>
<?
	if($ord){
		$sort = "type";
	}else{
		$sort = "name";
	}
	$query	= GenQuery('devices','s','name,type,serial,os,bootimage',$sort,'',array('type'),array('regexp'),array($flt) );
	$res	= @DbQuery($query,$link);

	$link_ccc = @DbConnect($dbhost,$dbuser,$dbpass,$dbname);

	if($res){
		$dev = 0;
		$row = 0;
		while( $d = @DbFetchRow($res) ){
			$dev++;
			$ud = rawurlencode($d[0]);
			echo "<tr class=\"imgb\" class=\"blu\"><th>\n";
			echo "<a href=\"Devices-Status.php?dev=$ud\"><b>$d[0]</b></a></th>\n";

	//$query_ccc = GenQuery('cisco_contracts','s','service_level,contract_number,end_date,DATEDIFF(STR_TO_DATE(end_date, '%d-%b-%Y'),CURDATE())','','',array('serial'),array('='),array($d[2]));
	$query_ccc = "SELECT service_level,contract_number,end_date,DATEDIFF(STR_TO_DATE(end_date, '%d-%b-%Y'),CURDATE()) FROM cisco_contracts WHERE serial_number=\"$d[2]\"";
	$res_ccc = @DbQuery($query_ccc,$link_ccc);
	$ccc = @DbFetchRow($res_ccc);
	if ($ccc[3] > 30) {
		$color = "green";
		$ccc_message = "$ccc[0]<br>Contract #$ccc[1] valid till $ccc[2]";
	} elseif ($ccc[3] > 1) {
		$color = "darkyellow";
		$ccc_message = "$ccc[0]<br>Contract #$ccc[1] valid till $ccc[2]";
	} else {
		$color = "red";
		$ccc_message = "$ccc[0]<br>Contract #$ccc[1] expired since $ccc[2] !";
	}
	if ($ccc[1] == "") {
		$color = "blue";
		$ccc_message = "Unknown";
	}
			echo "<td align=right>-</td><td><b>$d[1]</b></td><td>$d[2]</td><td><font color=$color>$ccc_message</font></td></tr>\n";

			$mquery	= GenQuery('modules','s','*','slot','',array('device'),array('='),array($d[0]));
			$mres	= @DbQuery($mquery,$link);
			if($mres){
				while( ($m = @DbFetchRow($mres)) ){
					if ($row % 2){$bg = "txta";}else{$bg = "txtb";}
					$row++;
					echo "<tr class=\"$bg\"><th>\n";
					$query_ccc = "SELECT service_level,contract_number,end_date,DATEDIFF(STR_TO_DATE(end_date, '%d-%b-%Y'),CURDATE()) FROM cisco_contracts WHERE serial_number=\"$m[2]\"";
					$res_ccc = @DbQuery($query_ccc,$link_ccc);
					$ccc = @DbFetchRow($res_ccc);
					if ($ccc[3] > 30) {
						$color = "green";
						$ccc_message = "$ccc[0]<br>Contract #$ccc[1] valid till $ccc[2]";
					} elseif ($ccc[3] > 1) {
						$color = "darkyellow";
						$ccc_message = "$ccc[0]<br>Contract #$ccc[1] valid till $ccc[2]";
					} else {
						$color = "red";
						$ccc_message = "$ccc[0]<br>Contract #$ccc[1] expired since $ccc[2]";
					}
					if ($ccc[1] == "") {
						$color = "blue";
						$ccc_message = "Unknown";
					}
					echo "<td align=right>$m[1]</td><td><b>$m[2]</b> $m[3]</td><td>$m[4]</td><td><font color=$color>$ccc_message</font></td></tr>\n";
				}
				@DbFreeResult($mres);
			}else{
				print @DbError($link);
				die;
			}
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
		die;
	}
	?>
</table>
<table class="content" >
<tr class="<?=$modgroup[$self]?>2"><td><?=$dev?> devices, <?=$row?> modules</td></tr>
</table>
	<?
}

include_once ("inc/footer.php");
?>
