#!/usr/bin/perl
#============================================================================
#
# Program: Devsend.pl
# Programmer: Remo Rickli
#
# -> Send commands to devices via libcli-sshnet <-
#
# DATE	COMMENT
# --------------------------------------------------------------------------
# 14/04/05	initial version
# 24/07/07	 better OS handling & cmd output
# 29/11/07	 Nortel support
# 16/01/08	Simplified approach; now exlusively for new libcli-sshnet.pl
# 20/09/08	Only calls cli::SendCmd, for proper integration with other libcli's
#============================================================================
#use strict;
use Net::Telnet;
use vars qw($p $now %opt);

#$opt{d} = "1";												# Turn debugging on
$now = time;

select(STDOUT);
$| = 1;

die "7 arguments needed not " . @ARGV . "!\n" if @ARGV != 7;

$p = shift(@ARGV);

require "$p/inc/libmisc.pl" || die "Can't open libmisc.pl!";
&misc::ReadConf();
require "$p/inc/libcli-" . lc($misc::clilib) . ".pl" || die "Clilib error ($misc::clilib)!";

&cli::SendCmd(@ARGV);
