<?PHP

//===================================================================
// Device related functions
//===================================================================

//===================================================================
// sort based on floor
function Floorsort($a, $b){

	if (is_numeric($a) and is_numeric($b) ){
		if ($a == $b) return 0;
		return ($a > $b) ? -1 : 1;
	}else{
		return strnatcmp ( $a,$b );
	}
}

//===================================================================
// Return Sys Services
function Syssrv($sv){

	$srv = "";

	if ($sv &  1) {$srv = " Repeater"; }
	if ($sv &  2) {$srv = "$srv Bridge"; }
	if ($sv &  4) {$srv = "$srv Router"; }
	if ($sv &  8) {$srv = "$srv Gateway"; }
	if ($sv & 16) {$srv = "$srv Session"; }
	if ($sv & 32) {$srv = "$srv Terminal"; }
	if ($sv & 64) {$srv = "$srv Application"; }
	if (!$sv)     {$srv = "-"; }

	return $srv;
}

//===================================================================
// Return VTP mode
function VTPmod($vn){

	if 	($vn == 1)	{return "client(1)"; }
	elseif	($vn == 2)	{return "server(2)"; }
	elseif	($vn == 3)	{return "transparent(3)"; }
	elseif	($vn == 4)	{return "off(4)"; }
	elseif	($vn == 9)	{return "error"; }
	else			{return "none (0)"; }
}

//===================================================================
// Return city image
function CtyImg($nd){

	if($nd > 19){
		return "cityx";
	}elseif($nd > 9){
		return "cityl";
	}elseif($nd > 2){
		return "citym";
	}else{
		return "citys";
	}
}

//===================================================================
// Returns link for CLI access based on IP and port
function DevCli($ip,$p){

	if(!$ip or $ip == "0.0.0.0" or !$p){
		return "$ip";
	}else{
		if($p == 22){
			return "<a href=\"ssh://$ip\">$ip</a>";
		}elseif($p == 23){
			return "<a href=\"telnet://$ip\">$ip</a>";
		}else{
			return "<a href=\"telnet://$ip:$p\">$ip</a>";
		}
	}
}

//===================================================================
// Return building image
function BldImg($nd,$na){

	global $redbuild;
	
	if( preg_match("/$redbuild/",$na) ){
		$bc = "r";
	}else{
		$bc = "";
	}
	if($nd > 19){
		return "bldh$bc";
	}elseif($nd > 9){
		return "bldb$bc";
	}elseif($nd > 2){
		return "bldm$bc";
	}else{
		return "blds$bc";
	}	
}

//===================================================================
// Return Interface Type
function Iftype($it){

	if ($it == "5"){$img = "tel";$tit="rfc877x25";
	}elseif ($it == "6"){$img = "p45";$tit="ethernetCsmacd";
	}elseif ($it == "7"){$img = "p45";$tit="iso88023Csmacd";
	}elseif ($it == "18"){$img = "tel";$tit="ds1";
	}elseif ($it == "19"){$img = "tel";$tit="E1";
	}elseif ($it == "22"){$img = "ppp";$tit="propPointToPointSerial";
	}elseif ($it == "23"){$img = "ppp";$tit="ppp";
	}elseif ($it == "24"){$img = "tape";$tit="softwareLoopback";
	}elseif ($it == "28"){$img = "ppp";$tit="slip";
	}elseif ($it == "32"){$img = "ppp";$tit="frameRelay DTE only";
	}elseif ($it == "37"){$img = "ppp";$tit="atm";
	}elseif ($it == "39"){$img = "neto";$tit="sonet";
	}elseif ($it == "44"){$img = "plug";$tit="frameRelayService";
	}elseif ($it == "49"){$img = "netr";$tit="AAL5 over ATM";
	}elseif ($it == "50"){$img = "neto";$tit="sonetPath";
	}elseif ($it == "51"){$img = "neto";$tit="sonetVT";
	}elseif ($it == "53"){$img = "chip";$tit="propVirtual";
	}elseif ($it == "56"){$img = "netr";$tit="fibreChannel";
	}elseif ($it == "58"){$img = "netg";$tit="frameRelayInterconnect";
	}elseif ($it == "63"){$img = "tel";$tit="isdn";
	}elseif ($it == "71"){$img = "ant";$tit="radio spread spectrum";
	}elseif ($it == "75"){$img = "tel";$tit="isdns";
	}elseif ($it == "77"){$img = "plug";$tit="lapd";
	}elseif ($it == "81"){$img = "tel";$tit="ds0";
	}elseif ($it == "101"){$img = "tel";$tit="voiceFX0";
	}elseif ($it == "102"){$img = "tel";$tit="voiceFXS";
	}elseif ($it == "103"){$img = "tel";$tit="voiceEncap";
	}elseif ($it == "104"){$img = "tel";$tit="voiceOverlp";
	}elseif ($it == "131"){$img = "plug";$tit="Encapsulation interface";
	}elseif ($it == "134"){$img = "netr";$tit="ATM Sub Interface";
	}elseif ($it == "135"){$img = "chip";$tit="Layer 2 Virtual LAN using 802.1Q";
	}elseif ($it == "150"){$img = "netg";$tit="mplsTunnel";
	}elseif ($it == "166"){$img = "netg";$tit="mpls";
	}elseif ($it == "171"){$img = "neto";$tit="Packet over SONET/SDH Interface";
	}elseif ($it == "209"){$img = "plug";$tit="Transparent bridge interface";
	}else{$img = "qg";$tit="Other-$it";}

	return array("$img.png",$tit);
}

//===================================================================
// Generate location string for DB query
function TopoLoc($reg="",$cty="",$bld=""){

	global $locsep;
	$l = "";
	if($reg or $cty or $bld){								# Any sub locations?
		$l .= "^$reg$locsep";								# Start at region level
		$l .= ($cty)?"$cty$locsep":"";							# Append city if set
		$l .= ($bld)?"$bld$locsep":"";							# Append building if set
	}
	return $l;
}

//===================================================================
// Find best map using a nice recursive function
function TopoMap($reg="",$cty=""){
	if($reg){
		if($cty){
			if (file_exists("log/map-$reg-$cty.png")) {
				return "map-$reg-$cty.png";
			}else{
				return TopoMap($reg);
			}
		}else{
			if (file_exists("log/map-$reg.png")) {
				return "map-$reg.png";
			}
		}
	}
	return "map-top.png";
}

//===================================================================
// Return Printer Supply Type
function PrintSupply($t){
	
	if 	($t == 1)	{return "<img src=\"img/16/paint.png\" title=\"other\">";}
	elseif	($t == 2)	{return "<img src=\"img/16/paint.png\" title=\"unknown\">";}
	elseif	($t == 3)	{return "<img src=\"img/16/paint.png\" title=\"toner\">";}
	elseif	($t == 4)	{return "<img src=\"img/16/bdis.png\" title=\"wasteToner\">";}
	elseif	($t == 5)	{return "<img src=\"img/16/hlth.png\" title=\"ink\">";}
	elseif	($t == 6)	{return "<img src=\"img/16/pcm.png\" title=\"inkCartridge\">";}
	elseif	($t == 7)	{return "<img src=\"img/16/pcm.png\" title=\"inkRibbon\">";}
	elseif	($t == 8)	{return "<img src=\"img/16/bdis.png\" title=\"wasteInk\">";}
	elseif	($t == 9)	{return "opc";}
	elseif	($t == 10)	{return "<img src=\"img/16/geom.png\" title=\"developer\">";}
	elseif	($t == 11)	{return "<img src=\"img/16/tap.png\" title=\"fuserOil\">";}
	elseif	($t == 12)	{return "solidWax";}
	elseif	($t == 13)	{return "<img src=\"img/16/pcm.png\" title=\"ribbonWax\">";}
	elseif	($t == 14)	{return "<img src=\"img/16/bdis.png\" title=\"wasteWax\">";}
	elseif	($t == 15)	{return "<img src=\"img/16/tap.png\" title=\"fuser\">";}
	elseif	($t == 16)	{return "coronaWire";}
	elseif	($t == 17)	{return "fuserOilWick";}
	elseif	($t == 18)	{return "cleanerUnit";}
	elseif	($t == 19)	{return "transferUnit";}
	elseif	($t == 20)	{return "<img src=\"img/16/pcm.png\" title=\"tonerCartridge\">";}
	elseif	($t == 21)	{return "<img src=\"img/16/pcm.png\" title=\"tonerCartridge\">";}
	elseif	($t == 22)	{return "<img src=\"img/16/tap.png\" title=\"fuserOiler\">";}
	elseif	($t == 23)	{return "<img src=\"img/16/tap.png\" title=\"water\">";}
	elseif	($t == 24)	{return "<img src=\"img/16/bdis.png\" title=\"wasteWater\">";}
	elseif	($t == 25)	{return "<img src=\"img/16/tap.png\" title=\"glueWaterAdditive\">";}
	elseif	($t == 26)	{return "<img src=\"img/16/bcnl.png\" title=\"wastePaper\">";}
	elseif	($t == 27)	{return "<img src=\"img/16/clip.png\" title=\"bindingSupply\">";}
	elseif	($t == 28)	{return "<img src=\"img/16/clip.png\" title=\"bandingSupply\">";}
	elseif	($t == 29)	{return "<img src=\"img/16/clip.png\" title=\"stitchingWire\">";}
	elseif	($t == 30)	{return "<img src=\"img/16/news.png\" title=\"shrinkWrap\">";}
	elseif	($t == 31)	{return "<img src=\"img/16/news.png\" title=\"paperWrap\">";}
	elseif	($t == 32)	{return "<img src=\"img/16/clip.png\" title=\"staples\">";}
	elseif	($t == 33)	{return "<img src=\"img/16/icon.png\" title=\"inserts\">";}
	elseif	($t == 34)	{return "<img src=\"img/16/fobl.png\" title=\"covers\">";}
	else			{return "-";}
}
?>
