<?PHP

//===============================
// Monitoring related functions (and variables)
//===============================

// Message icons based on level
$mico['10']  = "fogy";
$mico['50']  = "fogr";
$mico['100'] = "fobl";
$mico['150'] = "fovi";
$mico['200'] = "foor";
$mico['250'] = "ford";

//===================================================================
// Assign an icon to an incident category.
function Cimg($cat){

	if($cat == 1)		{return "star";}
	elseif($cat == 2)	{return "ugrp";}
	elseif($cat < 10)	{return "bbox";}
	elseif($cat == 11)	{return "flas";}
	elseif($cat == 12)	{return "dril";}
	elseif($cat == 13)	{return "ele";}
	elseif($cat < 20)	{return "home";}
	elseif($cat == 21)	{return "batt";}
	elseif($cat == 23)	{return "pcm";}
	elseif($cat == 24)	{return "cog";}
	elseif($cat == 25)	{return "radr";}
	elseif($cat < 30)	{return "dev";}
	elseif($cat == 31)	{return "flop";}
	elseif($cat == 32)	{return "conf";}
	elseif($cat == 33)	{return "eyes";}
	elseif($cat == 34)	{return "hat";}
	elseif($cat < 40)	{return "user";}
}
//===================================================================
// Return bg color based on monitoring status
function StatusBg($n,$m,$a,$bg){
	
	global $pause,$tim,$errlbl;

	$downtime = $a * $pause;

	if($m){
		if ($n == 1){
			if($downtime > 86400){
				return array ("crit","> 1 $tim[d]");
			}elseif($downtime > 3600){
				return array ("alrm","> 1 $tim[h]");
			}elseif($downtime > 0){
				return array ("warn",$tim['n']);
			}else{
				return array ("good","OK");
			}
		}else{
			if($a > 1){
				return array ("alrm","$a $errlbl");
			}elseif($a){
				return array ("warn","$errlbl $tim[n]");
			}else{
				return array ("good","OK");
			}
		}
	}else{
		return array ($bg,"");
	}
}

//===================================================================
// Generate If status tables
function StatusIf($btn,$label){

	global $link,$lim,$rrdstep,$trfa,$modgroup,$self;
	
	if($btn   == "brup"){
		$type = 1;
		$query	= GenQuery('interfaces','s','device,ifname,speed,type,dinerr','dinerr desc',$lim,array('dinerr','type'),array('>','!='),array("$rrdstep",'71'),array('AND'));
	}elseif($btn   == "brdn"){
		$type = 1;
		$query	= GenQuery('interfaces','s','device,ifname,speed,type,douterr','douterr desc',$lim,array('douterr','type'),array('>','!='),array("$rrdstep",'71'),array('AND'));
	}elseif($btn   == "bbup"){
		$type = 0;
		$query	= GenQuery('interfaces','s',"device,ifname,speed,type,dinoct*800/speed/$rrdstep",'dinoct/speed desc',$lim,array("dinoct*800/speed/$rrdstep"),array('>'),array($trfa));
	}elseif($btn   == "bbdn"){
		$type = 0;
		$query	= GenQuery('interfaces','s',"device,ifname,speed,type,doutoct*800/speed/$rrdstep",'doutoct/speed desc',$lim,array("doutoct*800/speed/$rrdstep"),array('>'),array($trfa));
	}elseif($btn   == "bdis"){
		$type = 2;
		$query	= GenQuery('interfaces','s','device,ifname,speed,type,status','device',$lim,array('status'),array('='),array("130"));
	}
	$res	= @DbQuery($query,$link);
	if($res){
		$nr = @DbNumRows($res);
		if($nr){
	?>
	<p>
	<table class="content"><tr class="<?=$modgroup[$self]?>2">
	<th colspan="2"><img src="img/16/port.png" title="Top <?=$lim?>"><br>Interface</th><th><img src="img/16/<?=$btn?>.png"><br><?=(substr($label,0,3))?></th>
	<?
			$row = 0;
			while( ($t = @DbFetchRow($res)) ){
				if ($row % 2){$bg = "txta"; $bi = "imga";$off=200;}else{$bg = "txtb"; $bi = "imgb";$off=185;}
				$row++;
				$bg3= sprintf("%02x",$off);
				$tb = ($type)?$t[4]*5:($t[4]-$trfa)*2;
				if ($tb > 55){$tb = 55;}
				$rb = sprintf("%02x",$tb + $off);
				$ud	= rawurlencode($t[0]);
				$ui	= rawurlencode($t[1]);
				list($ifimg,$iftit) = Iftype($t[3]);
				echo "<tr bgcolor=\"#$rb$bg3$bg3\"><th class=\"$bi\" width=\"25\"><img src=img/$ifimg title=\"$iftit\">";
				echo "</th><td><a href=Devices-Status.php?dev=$ud&shg=on&shp=on>$t[0]</a> ";
				echo "<a href=Nodes-List.php?ina=device&opa==&sta=$ud&cop=AND&inb=ifname&opb==&stb=$ui>$t[1]</a> ".Zfix($t[2])."</td><th>\n";
				if($type == 2){
					echo ($t[4] == 130)?"Admin":"?";
				}elseif($type == 1){
					echo $t[4];
				}else{
					echo sprintf("%1.1f",$t[4])." %";
				}
				echo "</th></tr>\n";
			}
			echo "</table>\n";
		}elseif(!$_SESSION['gsiz']){
			?><p><img src="img/32/<?=$btn?>.png" title="<?=$label?>" hspace="8"><img src="img/32/bchk.png" title="OK"><?
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
	}
}

//===================================================================
// Generate system status tables
function StatusSys($btn,$label){

	global $link,$lim,$cpua,$mema,$tmpa,$modgroup,$self;

	if($btn =="cpu"){
		$query	= GenQuery('devices','s','name,cpu','cpu desc',$lim,array('cpu'),array('>'),array($cpua));
		$unit  = "%";
	}elseif($btn =="mem"){
		$query	= GenQuery('devices','s','name,memcpu','memcpu desc',$lim,array('memcpu','memcpu'),array('<','>'),array($mema,1),array('AND'));
		$unit  = "B";
	}elseif($btn =="home"){
		$query	= GenQuery('devices','s','name,temp','temp desc',$lim,array('temp'),array('>'),array($tmpa));
		$unit  = "C";
	}
	$res	= @DbQuery($query,$link);
	if($res){
		$nr = @DbNumRows($res);
		if($nr){
	?>
	<p>
	<table class="content"><tr class="<?=$modgroup[$self]?>2">
	<th colspan="2"><img src="img/16/dev.png" title="Top <?=$lim?>"><br>Device</th><th><img src="img/16/<?=$btn?>.png"><br><?=$label?></th>
	<?
			$row = 0;
			while( ($t = @DbFetchRow($res)) ){
				if ($row % 2){$bg = "txta"; $bi = "imga";$off=200;}else{$bg = "txtb"; $bi = "imgb";$off=185;}
				$row++;
				$bg3= sprintf("%02x",$off);
				if($mode == "cpu"){
					$tb = $t[1]-$cpua;
				}elseif($mode == "mem"){
					$tb = ($mema - $t[1])/10000;
				}elseif($mode == "tmp"){
					$tb = pow(($t[1]-$tmpa),2);
				}
				if ($tb > 55){$tb = 55;}
				$rb = sprintf("%02x",$tb + $off);
				$ud	= rawurlencode($t[0]);
				echo "<tr bgcolor=\"#$rb$bg3$bg3\"><th class=\"$bi\">$row</th><td><a href=Devices-Status.php?dev=$ud>$t[0]</a></td>\n";
				echo "<th>$t[1] $unit</th></tr>\n";
			}
			echo "</table>\n";
		}else{
			?><p><img src="img/32/<?=$btn?>.png" title="<?=$label?>" hspace="8"><img src="img/32/bchk.png" title="OK"><?
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
	}
}

//===================================================================
// Displays Messages based on query in 2 sizes
function Messages($query,$s=1){

	global $link,$modgroup,$self,$levlbl,$timlbl,$srclbl,$msglbl,$stalbl,$cfglbl,$cmdlbl,$bg,$bi,$mico,$mlvl,$datfmt;

	$res	= @DbQuery($query,$link);
	if($res){
		$nmsg = @DbNumRows($res);
		if($nmsg){
			$row  = 0;
			if($s == 1){
?>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width="40"><img src="img/16/idea.png"><br><?=$levlbl?></th>
<th width="100"><img src="img/16/clock.png"><br><?=$timlbl?></th>
<th><img src="img/16/dev.png"><br><?=$srclbl?></th>
<th><img src="img/16/find.png"><br>Info</th>
</tr>
<?
				while( ($m = @DbFetchRow($res)) ){
					if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
					$row++;
					$time = date($datfmt,$m[2]);
					$fd   = rawurlencode(date("m/d/Y H:i:s",$m[2]));
					$usrc = rawurlencode($m[3]);
					echo "<tr class=\"$bg\"><th class=\"$bi\"><a href=Monitoring-Messages.php?ina=level&opa==&sta=$m[1]>\n";
					echo "<img src=\"img/16/" . $mico[$m[1]] . ".png\" title=\"" . $mlvl[$m[1]] . "\"></a></th>\n";
					echo "<td><a href=Monitoring-Messages.php?ina=time&opa==&sta=$fd>$time</a></td><td>\n";
					echo "<a href=Monitoring-Messages.php?ina=source&opa==&sta=$usrc>$m[3]</a></td><td>$m[4]</td></tr>\n";
				}
				echo "</table>\n";
			}else{
?>
<table class="content"><tr class="<?=$modgroup[$self]?>2">
<th width="80"><img src="img/16/eyes.png"><br>Id</th>
<th width="50"><img src="img/16/idea.png" title="10=<?=$mlvl['10']?>,50=<?=$mlvl['50']?>, 100=<?=$mlvl['100']?>, 150=<?=$mlvl['150']?>, 200=<?=$mlvl['200']?>, 250=<?=$mlvl['250']?>"><br><?=$levlbl?></th>
<th width="120"><img src="img/16/clock.png"><br><?=$timlbl?></th>
<th><img src="img/16/dev.png" title="Device (if in devices) or IP (will only produce level <50)"><br><?=$srclbl?></th>
<th width="50"><img src="img/16/cog.png" title="Action based on message info"><br><?=$cmdlbl?></th>
<th width="60%"><img src="img/16/find.png"><br>Info</th>
</tr>
<?
				while( ($m = @DbFetchRow($res)) ){
					if ($row % 2){$bg = "txta"; $bi = "imga";}else{$bg = "txtb"; $bi = "imgb";}
					$row++;
					$time = date($datfmt,$m[2]);
					$fd   = rawurlencode(date("m/d/Y H:i:s",$m[2]));
					$ud   = rawurlencode($m[3]);
					echo "<tr class=\"$bg\"><th><a href=\"Monitoring-Messages.php?ina=id&opa==&sta=$m[0]\">$m[0]</a></th>\n";
					echo "<th class=\"$bi\"><a href=\"Monitoring-Messages.php?ina=level&opa==&sta=$m[1]\"><img src=\"img/16/" . $mico[$m[1]] . ".png\" title=\"" . $mlvl[$m[1]] . "\"></a></th>\n";
					echo "<td><a href=\"Monitoring-Messages.php?ina=time&opa==&sta=$fd\">$time</a></td><th><a href=\"Monitoring-Messages.php?ina=source&opa==&sta=$ud\">$m[3]</a></th><th>\n";
					$action = "<a href=\"Devices-Status.php?dev=$ud\"><img src=\"img/16/sys.png\" title=\"$stalbl\"></a>";
					if($m[1] < 50){
						$action = "<a href=\"Nodes-List.php?ina=ip&opa==&sta=$m[3]\"><img src=\"img/16/cubs.png\" title=\"Nodes\"></a>";
					}elseif( preg_match("/[cC]onfig(ured from| changed| Backup)/",$m[4]) ){
						$action .=  "<a href=\"Devices-Config.php?shc=$ud\"><img src=\"img/16/conf.png\" title=\"$cfglbl\"></a>";
					}elseif( strstr($m[4],"not discoverable") ){
						$action = "<a href=\"Nodes-List.php?ina=ip&opa==&sta=$m[3]\"><img src=\"img/16/cubs.png\" title=\"Nodes\"></a>";
					}elseif( preg_match("/(reappeared|ARP entries)/",$m[4]) ){
						$action = "<a href=\"Nodes-Status.php?mac=$m[3]\"><img src=\"img/16/node.png\" title=\"$stalbl\"></a>";
					}
					echo "$action</th><td>". preg_replace('/([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})/', '<span class=\'blu\'>$1</span><a href="Nodes-List.php?ina=ip&opa=%3D&sta=$1"><img src="img/16/cubs.png" title="Nodes"></a><a href="http://www.ip2location.com/$1" target="window"><img src="img/16/ncon.png" title="ip2location"></a>', $m[4]) ."</td></tr>\n";
				}
?>
</table>
<table class="content">
<tr class="<?=$modgroup[$self]?>2"><td><?=$row?> <?=$msglbl?> (<?=$query?>)</td></tr>
</table>
<?

			}
		}else{
			echo "<p><h5>0 $msglbl</h5>";	
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
	}
}


//===================================================================
// Generate device metainfo for topology based device tables
function TopoTable($reg="",$cty="",$bld=""){

	global $link,$dev,$deval,$dcity,$dbuild,$locsep;

	$query	= GenQuery('devices','s','*','','',array('location'),array('regexp'),array( TopoLoc($reg,$cty,$bld) ) );
	$res	= @DbQuery($query,$link);
	if($res){
		while( ($d = @DbFetchRow($res)) ){
			$l = explode($locsep, $d[10]);
			if( isset($deval[$d[0]]) ){						# Device is monitored if set...
				$dcity[$l[0]][$l[1]]['mn']++;
				$dcity[$l[0]][$l[1]]['al'] += $deval[$d[0]];
				$dbuild[$l[0]][$l[1]][$l[2]]['mn']++;
				$dbuild[$l[0]][$l[1]][$l[2]]['al'] += $deval[$d[0]];
				$mn = 1;
			}else{
				$mn = 0;
			}
			if (!$cty){
				$dcity[$l[0]][$l[1]]['nd']++;
			}elseif (!$bld){
				$dbuild[$l[0]][$l[1]][$l[2]]['nd']++;
				if($d[6] > 3){$dbuild[$l[0]][$l[1]][$l[2]]['nr']++;}
			}else{
				$dev[$l[3]][$l[4]][$d[0]]['rk'] = "$l[5] <i>$l[6]</i>";
				$dev[$l[3]][$l[4]][$d[0]]['ip'] = $d[1];
				$dev[$l[3]][$l[4]][$d[0]]['ty'] = $d[3];
				$dev[$l[3]][$l[4]][$d[0]]['co'] = $d[11];
				$dev[$l[3]][$l[4]][$d[0]]['po'] = $d[16];
				$dev[$l[3]][$l[4]][$d[0]]['ic'] = $d[18];
				$dev[$l[3]][$l[4]][$d[0]]['mn'] = $mn;
				$dev[$l[3]][$l[4]][$d[0]]['al'] = $deval[$d[0]];
				
			}
		}
		@DbFreeResult($res);
	}else{
		print @DbError($link);
	}
}

//===================================================================
// Generate region table
function TopoCities($mcol){

	global $dcity,$locsep,$bg2,$netlbl;

	echo "<h2>Corporate $netlbl</h2>\n";
	echo "<table class=\"content fixed\"><tr>\n";

	$col = 0;
	$rec = 0;
	ksort($dcity);
	foreach (array_keys($dcity) as $r){
		if ($rec == "1"){ $rec = "0"; $bi = "imga"; }
		else{ $rec = "1"; $bi = "imgb"; }	
		$ur = rawurlencode($r);
		ksort($dcity[$r]);
		foreach (array_keys($dcity[$r]) as $c){
			$nd = $dcity[$r][$c]['nd'];
			$ci = CtyImg($dcity[$r][$c]['nd']);
			$mn = isset( $dcity[$r][$c]['mn']) ? $dcity[$r][$c]['mn'] : 0;
			$al = isset( $dcity[$r][$c]['al']) ? $dcity[$r][$c]['al'] : 0;
			list($statbg,$stat) = StatusBg($nd,$mn,$al,$bi);
			$uc = rawurlencode($c);
			if ($col == $mcol){
				$col = 0;
				echo "</tr><tr>";
			}
	                echo "<td class=\"$statbg\" valign=top>$r<p><center><a href=?reg=$ur&cty=$uc>\n";
			echo "<img src=\"img/$ci.png\" title=\"$nd devices $stat\"></a>\n";
			echo "<br><a href=\"Devices-List.php?ina=location&opa=regexp&sta=%5E$ur$locsep$uc$locsep\">";
			echo "<b>$c</a><b></center></td>\n";
	                $col++;
		}
	}
	echo "</tr></table>\n";
}

//===================================
//================================
// Generate city table
function TopoBuilds($r,$c,$mcol){

	global $dbuild,$locsep,$redbuild,$bg2;

	$ur = rawurlencode($r);
	$uc = rawurlencode($c);

	echo "<h2>$r - $c</h2>\n";
	echo "<table class=\"content fixed\"><tr>\n";

	$col = 0;
	ksort($dbuild[$r][$c]);
	foreach (array_keys($dbuild[$r][$c]) as $b){
		$nr =  $dbuild[$r][$c][$b]['nr'];
		$nd =  $dbuild[$r][$c][$b]['nd'];
		$mn = isset( $dbuild[$r][$c][$b]['mn']) ? $dbuild[$r][$c][$b]['mn'] : 0;
		$al = isset( $dbuild[$r][$c][$b]['al']) ? $dbuild[$r][$c][$b]['al'] : 0;
		$bi = BldImg($nd,$b);
		list($statbg,$stat) = StatusBg($nd,$mn,$al,"imga");
		if($nr > 1){
			$ri = "<img src=\"img/rtr2.png\" title=\"$nr routers\">";
		}elseif($nr == 1){
			$ri = "<img src=\"img/rtr1.png\" title=\"1 router\">";
		}else{
			$ri = "";
		}
		$ub = rawurlencode($b);
		if ($col == $mcol){
			$col = 0;
			echo "</tr><tr>";
		}
		echo "<td class=\"$statbg\" valign=bottom align=center>\n";
		echo "<a href=?reg=$ur&cty=$uc&bld=$ub><img src=\"img/$bi.png\" title=\"$nd devices $stat\" border=0>$ri</a>\n";
		echo "<br><a href=\"Devices-List.php?ina=location&opa=regexp&sta=%5E$ur$locsep$uc$locsep$ub$locsep\">";
		echo "<b>$b</b></a>\n";
		echo "</td>\n";
		$col++;
	}
	echo "</tr></table>\n";
}

//===================================================================
// Generate building table
function TopoFloors($r,$c,$b,$mcol){

	global $dev,$modgroup,$self;

	echo "<h2>$r - $c - $b</h2>\n";
	echo "<table class=\"content fixed\">\n";
	uksort($dev, "floorsort");
	$room = 0;
	foreach (array_keys($dev) as $fl){
		echo "<tr>\n\t<td class=\"$modgroup[$self]2\" width=80><h3><img src=\"img/stair.png\"><br>$fl</h3></td>\n";
		$col = 0;
		ksort( $dev[$fl] );
		foreach (array_keys($dev[$fl]) as $rm){
			if ($room == "1"){ $room = "0"; $bi = "imga"; }
			else{ $room = "1"; $bi = "imgb"; }	

			foreach (array_keys($dev[$fl][$rm]) as $d){
				$ip = long2ip($dev[$fl][$rm][$d]['ip']);
				$po = $dev[$fl][$rm][$d]['po'];
				$di = $dev[$fl][$rm][$d]['ic'];
				$co = $dev[$fl][$rm][$d]['co'];
				$rk = $dev[$fl][$rm][$d]['rk'];
				$mn = $dev[$fl][$rm][$d]['mn'];
				$al = $dev[$fl][$rm][$d]['al'];
				list($statbg,$stat) = StatusBg('1',$mn,$al,$bi);
				$tit = ($stat)?$stat:$dev[$fl][$rm][$d]['ty'];
				$ud = rawurlencode($d);
				if ($col == $mcol){
					$col = 0;
					echo "</tr><tr><td>&nbsp;</td>\n";
				}
				echo "<td class=\"$statbg\" valign=top><b>$rm</b> $rk<p><center>\n";
				echo "<a href=\"Devices-Status.php?dev=$ud\"><img src=\"img/dev/$di.png\" title=\"$tit\"></a><br>\n";
				echo "<b>$d</b><br>\n";
				echo Devcli($ip,$po);
				echo"<p>$co</td>\n";
				$col++;
			}
		}
	}
	echo "</tr></table>\n";
}

?>
