<?
/*
#============================================================================
# Program: index.php (NeDi GUI)
# Programmer: Remo Rickli
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#============================================================================
# Visit http://www.nedi.ch/ for more information.
#============================================================================
# DATE		COMMENT
# -----------------------------------------------------------
# 22/02/05	initial version.
# 17/03/06	new SQL query support
# 30/08/07	implemented CSS scheme
# 19/03/08	Improved login with dynamic landing page
# 27/09/08	Radius integration
#============================================================================
*/
#error_reporting(E_ALL);

include_once ("inc/libmisc.php");
ReadConf('usr');
require_once ("inc/libdb-" . strtolower($backend) . ".php");

/* OPSERVICES START */
if ($loggedUser !== false) {

        @session_write_close();
        @session_start();
        $_SESSION['user'] = $loggedUser;
        $_SESSION['user'] = 'admin';
        $_SESSION['group'] = 'usr,adm,net,dsk,mon,mgr,oth,';
        $_SESSION['lang'] = 'english';
        $_SESSION['theme'] = 'default';
        $_SESSION['vol'] = 100;
        $_SESSION['col'] = 8;
        $_SESSION['lim'] = 10;
        $_SESSION['gsiz'] = 3;
        $_SESSION['gbit'] = 0;
        $_SESSION['gfar'] = 0;

}
/* OPSERVICES STOP */

$_POST = sanitize($_POST);
$_GET  = str_replace(";","", sanitize($_GET) );
$goto  = isset($_GET['goto']) ? $_GET['goto'] : "User-Profile.php";
/* OPSERVICES START */
$goto = "Devices-List.php";
/* OPSERVICES STOP */

if(isset( $_POST['user'])  ){
	$pass = md5( $_POST['pass'] );

	$link	= @DbConnect($dbhost,$dbuser,$dbpass,$dbname);
	if ( strstr($guiauth,'none') ){
		$uok	= 1;
		$query	= GenQuery('user','s','*','','',array('name'),array('='),array($_POST[user]) );
		$res    = @DbQuery($query,$link);
	}elseif ( strstr($guiauth,'pam') && $_POST['user'] != "admin" ){		# PAM code by Owen Brotherhood & Bruberg
		if (!extension_loaded ('pam_auth')){dl("pam_auth.so");}
		$uok	= pam_auth($_POST['user'],$_POST['pass']);
		$query	= GenQuery('user','s','*','','',array('name'),array('='),array($_POST[user]) );
		$res    = @DbQuery($query,$link);
	}elseif ( strstr($guiauth,'radius') && $_POST['user'] != "admin" ){		# Radius code by Till Elsner
		$radres = radius_auth_open();
		if (!$radres) {
			$raderr = "Error while preparing RADIUS authentication: ".radius_strerror($radres);
		}
		foreach ($radservers as $rs){
			if (!radius_add_server($radres, $rs[0], $rs[1], $rs[2], $rs[3], $rs[4])){
				echo "<h4>RADIUS: ".radius_strerror($radres)."</h4>";
			}
		}
		if (!radius_create_request($radres, RADIUS_ACCESS_REQUEST)) {
			$raderr = "RADIUS create: ".radius_strerror($radres);
		}
		if (!( radius_put_string($radres, RADIUS_USER_NAME, $_POST['user']) && radius_put_string($radres, RADIUS_USER_PASSWORD, $_POST['pass']) )){
			$raderr = "RADIUS put: ".radius_strerror($radres);
		}
		$radauth = radius_send_request($radres);
		if (!$radauth){
			$raderr = "RADIUS send: ".radius_strerror($radres);
		}else{
			switch ($radauth){
				case RADIUS_ACCESS_ACCEPT:
					$query	= GenQuery('user','s','*','','',array('name'),array('='),array($_POST['user']) );
					$res    = @DbQuery($query,$link);
					$uok	= mysql_num_rows($res);
					break;
				case RADIUS_ACCESS_REJECT:
					$raderr = "Incorrect RADIUS login!";
					break;
				case RADIUS_ACCESS_CHALLENGE:
					$raderr = "No RADIUS challenge handling yet!";
					break;
				default:
					$raderr = "Unknown RADIUS error!";
			}
		}
	}else{
		$pass = md5( $_POST['pass'] );
		$query	= GenQuery('user','s','*','','',array('name','password'),array('=','='),array($_POST['user'],$pass),array('AND') );
		$res    = @DbQuery($query,$link);
		$uok    = @DbNumRows($res);
	}

	if ($uok == 1) {
		$usr = @DbFetchRow($res);
		session_start(); 
		$_SESSION['user']	= $_POST['user'];
		$_SESSION['group']	= "usr,";
		if ($usr[2] &  1) {$_SESSION['group']	.= "adm,";}
		if ($usr[2] &  2) {$_SESSION['group']	.= "net,";}
		if ($usr[2] &  4) {$_SESSION['group']	.= "dsk,";}
		if ($usr[2] &  8) {$_SESSION['group']	.= "mon,";}
		if ($usr[2] & 16) {$_SESSION['group']	.= "mgr,";}
		if ($usr[2] & 32) {$_SESSION['group']	.= "oth,";}

		$_SESSION['lang'] = $usr[8];
		$_SESSION['theme']= $usr[9];
		$_SESSION['vol'] = $usr[10];
		$_SESSION['col'] = $usr[11];
		$_SESSION['lim'] = $usr[12];
		$_SESSION['gsiz'] = $usr[13] & 7;
		$_SESSION['gbit'] = $usr[13] & 8;
		$_SESSION['gfar'] = $usr[13] & 16;

		$now = time();
		$query	= GenQuery('user','u','name',$_POST['user'],'',array('lastseen'),'',array($now) );
		@DbQuery($query,$link);

	}else{
		print @DbError($link);
	}
	if(isset ($_SESSION['group'])){
		echo "<script>document.location.href='$goto';</script>\n";
	}elseif($raderr){
		$disc = "<h4>$raderr</h4>";
	} else {
		$disc = "<h4>Incorrect login!</h4>";
	}
} else {
	if(isset ($_SESSION['group']))
		echo "<script>document.location.href='$goto';</script>\n";
}

?>
<html>
<head><title>NeDi Login</title>
<link href="themes/default.css" type="text/css" rel="stylesheet">
<link rel="shortcut icon" href="img/favicon.ico">
</head>
<body onLoad="document.login.user.focus();">
<div align="center">
<form name="login" method="post" action="index.php?goto=<?=rawurlencode($goto)?>">
<table class="login">
<tr class="loginbg"><th colspan=3><a href='http://www.nedi.ch'><img src="img/nedib.png"></a></th></tr>
<tr class="txta">
<th align="center" colspan=3>
<img src="img/nedie<?=rand(1,7)?>.jpg">
<p><hr>
<?=$disc?>
</th></tr>
<tr class="loginbg">
<th>User <input type="text" name="user" size="12"></th>
<th>Pass <input type="password" name="pass" size="12"></th>
<th><input type="submit" value="Login">
</th>
</tr>
</table>
</form>
</div>

</body>
